/*************************************************
t@CFFileReader.h
쐬ҁ@@Fт
@@@Ft@Co
*************************************************/
/**
*	@file	FileReader.h
*	@brief	t@C͂sNX֌WłB
*/
#ifndef DX9A_FILE_FILEREADER_H
#define DX9A_FILE_FILEREADER_H

namespace nsDX9A{
namespace nsFile{
namespace nsFileReader{

//t@C̓NXiC^[tF[Xj
/**
*	@brief	t@C͂sNX̃C^[tF[XłB
*/
class IFileReader{
public:
/**
*	@brief	zfXgN^łB
*/
	virtual ~IFileReader(){}													//zfXgN^

/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/yeby3zcb(VS.80).aspx" target="_blank">fopen֐</a>̌݊\bhłB
*	@param	FileName	[in]I[vt@Cw肵܂B
*	@param	Mode		[in]t@C[hw肵܂B
*	@return	t@C̃I[vꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fopen(const char* FileName, const char* Mode) = 0;				//fopen
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/fxfsw25t(VS.80).aspx" target="_blank">fclose֐</a>̌݊\bhłB
*	@return	t@C̃N[YꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fclose() = 0;													//fclose
/**
*	@brief	t@CI[vĂ邩擾܂B
*	@return	t@CI[vĂꍇtrueAĂȂꍇfalseԂ܂B
*/
	virtual bool fisopen() = 0;													//fisopen
/**
*	@brief	t@CTCY擾܂B
*	@return	t@CTCYԂ܂iPʁFoCgj
*/
	virtual long fsize() = 0;													//fsize

/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/c7sskzc1(VS.80).aspx" target="_blank">fgetc֐</a>̌݊\bhłB
*	@param	c	[out]ǂݍ񂾕i[܂B
*	@return	̓ǂݍ݂ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fgetc(char* c) = 0;											//fgetc
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/c37dh6kf(VS.80).aspx" target="_blank">fgets֐</a>̌݊\bhłB
*	@param	s	[out]ǂݍ񂾕i[܂B
*	@param	n	[in]ǂݍލő啶w肵܂B
*	@return	̓ǂݍ݂ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fgets(char* s, int n) = 0;										//fgets
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/kt0etdcs(VS.80).aspx" target="_blank">fread֐</a>̌݊\bhłB
*	@param	buffer	[out]ǂݍ񂾃f[^i[܂B
*	@param	size	[in]ڂ̃TCYw肵܂B
*	@param	count	[in]ǂݍލő區ڐw肵܂B
*	@return	ۂɓǂݍ܂ꂽSȍڂ̐Ԃ܂B
*/
	virtual size_t fread(void* buffer, size_t size, size_t count) = 0;			//fread

/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/0ys3hc0b(VS.80).aspx" target="_blank">ftell֐</a>̌݊\bhłB
*	@return	݂̃t@CʒuԂ܂iPʁFoCgj
*/
	virtual long ftell() = 0;													//ftell
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/75yw9bf3(VS.71).aspx" target="_blank">fseek֐</a>̌݊\bhłB
*	@param	offset	[in]origiñoCgw肵܂B
*	@param	origin	[in]ʒuw肵܂B<br>
*					SEEK_CURFt@C|C^݈̌ʒułB<br>
*					SEEK_ENDFt@C̏I[łB<br>
*					SEEK_SETFt@C̐擪łB
*	@return	t@C|C^̈ړꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fseek(long offset, int origin) = 0;							//fseek
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/70hdhh4t(VS.80).aspx" target="_blank">fgetpos֐</a>̌݊\bhłB
*	@param	pos	[out]݂̃t@CʒuCWP[^i[܂iPʁFoCgj
*	@return	t@CʒuCWP[^̎擾ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fgetpos(fpos_t* pos) = 0;										//fgetpos
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/51hy3tts(VS.80).aspx" target="_blank">fsetpos֐</a>̌݊\bhłB
*	@param	pos		[in]VȈʒuCWP[^w肵܂iPʁFoCgj
*	@return	t@CʒuCWP[^̐ݒ肪ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fsetpos(const fpos_t* pos) = 0;								//fsetpos

/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/xssktc6e(VS.80).aspx" target="_blank">feof֐</a>̌݊\bhłB
*	@return	t@C̏I[zēǂݎ葀sꍇtrueԂAȊȌꍇfalseԂ܂B
*/
	virtual bool feof() = 0;													//feof
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/y2wc3w90(VS.80).aspx" target="_blank">ferror֐</a>̌݊\bhłB
*	@return	t@CXg[ɃG[Ȃꍇ0ԂAȊȌꍇ0ȊOԂ܂B
*/
	virtual int ferror() = 0;													//ferror
};

//t@C̓NXiNXj
/**
*	@brief	t@C͂sNX̊NXłB
*/
class CFileReader : public IFileReader{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	CFileReader();																//ftHgRXgN^
/**
*	@brief	RXgN^łB<br>
*			I[vt@Cƃt@C[hw肷邱ƂŁAɃt@C̃I[vs܂B
*	@param	FileName	[in]I[vt@Cw肵܂B
*	@param	Mode		[in]t@C[hw肵܂B
*/
	CFileReader(const char* FileName, const char* Mode);						//RXgN^
/**
*	@brief	fXgN^łB
*/
	~CFileReader();																//fXgN^

	bool fopen(const char* FileName, const char* Mode);							//fopen
	bool fclose();																//fclose
	bool fisopen();																//fisopen
	long fsize();																//fsize

	bool fgetc(char* c);														//fgetc
	bool fgets(char* s, int n);													//fgets
	size_t fread(void* buffer, size_t size, size_t count);						//fread

	long ftell();																//ftell
	bool fseek(long offset, int origin);										//fseek
	bool fgetpos(fpos_t* pos);													//fgetpos
	bool fsetpos(const fpos_t* pos);											//fsetpos

	bool feof();																//feof
	int ferror();																//ferror
protected:
/**
*	@brief	t@CXg[łB<br>
*			{oɑ΂Ae\bhős܂B
*/
	FILE* stream;																//t@CXg[
private:
	CFileReader(const CFileReader&);											//Rs[RXgN^i֎~j
	CFileReader& operator =(const CFileReader&);								//Zqi֎~j
};

//⏕֐
//Íǂݍ
/**
*	@brief	Íǂݍ݂܂B<br>
*			ÍASYXORÍłB
*	@param	FileReader	[in]ǂݍލۂɎgp\link	IFileReader	t@C̓NX\endlinkw肵܂B<br>
*						FileReader͊ɃI[vĂȂ΂Ȃ܂iǂݍ݌FileReaderŌ܂܂j
*	@param	CryptKey	[in]ÍL[w肵܂B
*	@param	Data		[out]ǂݍ񂾕i[܂B
*/
void LoadCryptedString(IFileReader* FileReader, BYTE CryptKey, string* Data);

}
}
}

#endif