/*************************************************
t@CFFileWriter.h
쐬ҁ@@Fт
@@@Ft@Co
*************************************************/
/**
*	@file	FileWriter.h
*	@brief	t@Co͂sNX֌WłB
*/
#ifndef DX9A_FILE_FILEWRITER_H
#define DX9A_FILE_FILEWRITER_H

namespace nsDX9A{
namespace nsFile{
namespace nsFileWriter{

//t@Co̓NXiC^[tF[Xj
/**
*	@brief	t@Co͂sNX̃C^[tF[XłB
*/
class IFileWriter{
public:
/**
*	@brief	zfXgN^łB
*/
	virtual ~IFileWriter(){}													//zfXgN^

/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/yeby3zcb(VS.80).aspx" target="_blank">fopen֐</a>̌݊\bhłB
*	@param	FileName	[in]I[vt@Cw肵܂B
*	@param	Mode		[in]t@C[hw肵܂B
*	@return	t@C̃I[vꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fopen(const char* FileName, const char* Mode) = 0;				//fopen
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/fxfsw25t(VS.80).aspx" target="_blank">fclose֐</a>̌݊\bhłB
*	@return	t@C̃N[YꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fclose() = 0;													//fclose
/**
*	@brief	t@CI[vĂ邩擾܂B
*	@return	t@CI[vĂꍇtrueAĂȂꍇfalseԂ܂B
*/
	virtual bool fisopen() = 0;													//fisopen
/**
*	@brief	t@CTCY擾܂B
*	@return	t@CTCYԂ܂iPʁFoCgj
*/
	virtual long fsize() = 0;													//fsize

/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/yah67377(VS.80).aspx" target="_blank">fputc֐</a>̌݊\bhłB
*	@param	c	[in]ޕw肵܂B
*	@return	݂̏ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fputc(char c) = 0;												//fputc
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/t33ya8ky(VS.80).aspx" target="_blank">fputs֐</a>̌݊\bhłB
*	@param	str	[in]ޕw肵܂B
*	@return	݂̏ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fputs(const char* str) = 0;									//fputs
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/h9t88zwz(VS.80).aspx" target="_blank">fwrite֐</a>̌݊\bhłB
*	@param	buffer	[in]ރf[^ւ̃|C^w肵܂B
*	@param	size	[in]ڂ̃TCYw肵܂B
*	@param	count	[in]ލő區ڐw肵܂B
*	@return	ۂɏ܂ꂽSȍڂ̐Ԃ܂B
*/
	virtual size_t fwrite(const void* buffer, size_t size, size_t count) = 0;	//fwrite
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/xkh07fe2(VS.80).aspx" target="_blank">fprintf֐</a>̌݊\bhłB
*	@param	format	[in]o͕w肵܂B<br>
*					fprintfƓ̏w肪\łB
*	@param	...		[in]o͂ϐw肵܂B<br>
*					fprintfƓ̏w肪\łB
*	@return	o͂oCgԂ܂B
*/
	virtual int __cdecl fprintf(const char* format, ...) = 0;					//fprintf

/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/0ys3hc0b(VS.80).aspx" target="_blank">ftell֐</a>̌݊\bhłB
*	@return	݂̃t@CʒuԂ܂iPʁFoCgj
*/
	virtual long ftell() = 0;													//ftell
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/75yw9bf3(VS.71).aspx" target="_blank">fseek֐</a>̌݊\bhłB
*	@param	offset	[in]origiñoCgw肵܂B
*	@param	origin	[in]ʒuw肵܂B<br>
*					SEEK_CURFt@C|C^݈̌ʒułB<br>
*					SEEK_ENDFt@C̏I[łB<br>
*					SEEK_SETFt@C̐擪łB
*	@return	t@C|C^̈ړꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fseek(long offset, int origin) = 0;							//fseek
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/70hdhh4t(VS.80).aspx" target="_blank">fgetpos֐</a>̌݊\bhłB
*	@param	pos	[out]݂̃t@CʒuCWP[^i[܂iPʁFoCgj
*	@return	t@CʒuCWP[^̎擾ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fgetpos(fpos_t* pos) = 0;										//fgetpos
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/51hy3tts(VS.80).aspx" target="_blank">fsetpos֐</a>̌݊\bhłB
*	@param	pos		[in]VȈʒuCWP[^w肵܂iPʁFoCgj
*	@return	t@CʒuCWP[^̐ݒ肪ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool fsetpos(const fpos_t* pos) = 0;								//fsetpos

/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/xssktc6e(VS.80).aspx" target="_blank">feof֐</a>̌݊\bhłB
*	@return	t@C̏I[zēǂݎ葀sꍇtrueԂAȊȌꍇfalseԂ܂B
*/
	virtual bool feof() = 0;													//feof
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/y2wc3w90(VS.80).aspx" target="_blank">ferror֐</a>̌݊\bhłB
*	@return	t@CXg[ɃG[Ȃꍇ0ԂAȊȌꍇ0ȊOԂ܂B
*/
	virtual int ferror() = 0;													//ferror
};

//t@Co̓NXiNXj
/**
*	@brief	t@Co͂sNX̊NXłB
*/
class CFileWriter : public IFileWriter{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	CFileWriter();																//ftHgRXgN^
/**
*	@brief	RXgN^łB<br>
*			I[vt@Cƃt@C[hw肷邱ƂŁAɃt@C̃I[vs܂B
*	@param	FileName	[in]I[vt@Cw肵܂B
*	@param	Mode		[in]t@C[hw肵܂B
*/
	CFileWriter(const char* FileName, const char* Mode);						//RXgN^
/**
*	@brief	fXgN^łB
*/
	~CFileWriter();																//fXgN^

	bool fopen(const char* FileName, const char* Mode);							//fopen
	bool fclose();																//fclose
	bool fisopen();																//fisopen
	long fsize();																//fsize

	bool fputc(char c);															//fputc
	bool fputs(const char* str);												//fputs
	size_t fwrite(const void* buffer, size_t size, size_t count);				//fwrite
	int __cdecl fprintf(const char* format, ...);								//fprintf

	long ftell();																//ftell
	bool fseek(long offset, int origin);										//fseek
	bool fgetpos(fpos_t* pos);													//fgetpos
	bool fsetpos(const fpos_t* pos);											//fsetpos

	bool feof();																//feof
	int ferror();																//ferror
protected:
/**
*	@brief	t@CXg[łB<br>
*			{oɑ΂Ae\bhős܂B
*/
	FILE* stream;																//t@CXg[
private:
	CFileWriter(const CFileWriter&);											//Rs[RXgN^i֎~j
	CFileWriter& operator =(const CFileWriter&);								//Zqi֎~j
};



//⏕֐
//Í
/**
*	@brief	Í݂܂B<br>
*			ÍASYXORÍłB
*	@param	FileWriter	[in]ލۂɎgp\link	IFileWriter	t@Co̓NX\endlinkw肵܂B<br>
*						FileWriter͊ɃI[vĂȂ΂Ȃ܂iݐFileWriterŌ܂܂j
*	@param	CryptKey	[in]ÍL[w肵܂B
*	@param	Data		[in]ÍΏۂ̕w肵܂B
*/
void SaveCryptedString(IFileWriter* FileWriter, BYTE CryptKey, const string& Data);

}
}
}

#endif