/*************************************************
t@CFDrawManagerfD.h
쐬ҁ@@Fт
@@@FAbyssLib̎NXiOtBbN֘Aj
*************************************************/
/**
*	@file	DrawManagerfD.h
*	@brief	AbyssLib̎NXiOtBbN֘AjłB
*
*			e\bhׂ̐ɂ͋L܂B<br>
*			e\bh̏ڍׂAbyssLib̃t@XQƂĂB
*/
#ifndef DX9A_FRAME_ABYSSLIB_DRAWMANAGERFD_H
#define DX9A_FRAME_ABYSSLIB_DRAWMANAGERFD_H
#ifdef USE_ABYSSLIB

namespace nsDX9A{
namespace nsFramework{
namespace nsAbyssLib{
namespace nsDrawManagerfD{

//OtBbNpfoCX
/**
*	@brief	AbyssLib̎NXiOtBbNpfoCXjłB
*
*			e\bhׂ̐ɂ͋L܂B<br>
*			e\bh̏ڍׂAbyssLib̃t@XQƂĂB
*/
class DrawManagerfD : public BaseDrawManager{
public:
/**
*	@brief	RXgN^łB
*	@param	GM				[in]֌W\link	nsDX9A::nsGraphics::nsDX9AGraphic::DX9AGraphic	DirectX Graphicsbp[NX\endlinkw肵܂B
*	@param	ColorKey		[in]F<a href="http://msdn.microsoft.com/ja-jp/library/bb172518(v=vs.85).aspx" target="_blank">D3DCOLOR</a>Ŏw肵܂B
*	@param	FPM				[in]OtBbNǂݍ݂ɗp\link	nsDX9A::nsFramework::nsFilePack::DX9AFilePack	t@CpbNǗNX\endlinkw肵܂B
*	@param	FilePackName	[in]t@CpbNw肵܂B<br>
*							󕶎w肵ꍇA܂͖w̏ꍇ̓t@CpbN̓ǂݍ݂͍s܂B
*/
	DrawManagerfD(DX9AGraphic* GM, D3DCOLOR ColorKey = 0, DX9AFilePack* FPM = NULL, const string& FilePackName = "");
															//RXgN^

	unsigned int GetScreenWidth() const;					//ʂ̉擾
	unsigned int GetScreenHeight() const;					//ʂ̏c擾
	bool GetFullScreen() const;								//tXN[ۂ擾
	void SetFullScreen(bool IsFullScreen);					//tXN[ۂݒ

	void Flip();											//ʂXV

/**
*	@brief	OtBbNǗNXiFj擾܂B
*	@param	FileName	[in]擾OtBbNǗNXiFj̉摜t@Cw肵܂B
*	@return	OtBbNǗNXiFjԂ܂B<br>
*			Ŷ݂Ȃꍇ́ANULLԂ܂B
*/
	IDraw2D* GetDrawer(const string& FileName);				//OtBbNǗNXiFj擾
/**
*	@brief	OtBbNǗNXiFȂj擾܂B
*	@param	FileName	[in]擾OtBbNǗNXiFȂj̉摜t@Cw肵܂B
*	@return	OtBbNǗNXiFȂjԂ܂B<br>
*			Ŷ݂Ȃꍇ́ANULLԂ܂B
*/
	IDraw2D* GetDrawerFast(const string& FileName);			//OtBbNǗNXiFȂj擾
private:
	DX9AGraphic* m_GM;										//DirectX Graphicsbp[NXւ̃|C^
	D3DCOLOR m_ColorKey;									//J[L[
	DX9AFilePack* m_FPM;									//t@CpbNǗNXւ̃|C^
	string m_FilePackName;									//t@CpbN
	IDraw2DHelper m_Draw2DMapList;							//摜`piFj
	IDraw2DHelper m_Draw2DFastMapList;						//摜`piFȂj

	bool _LoadImage(const char* FileName);
	bool _UnloadImage(const char* FileName);
	void _Clear(COLORREF Color);
	void _Blt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree);
	void _AddBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree);
	void _SubBlt(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree);
	void _BltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree);
	void _AddBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree);
	void _SubBltFast(const string& FileName, int x, int y, BYTE a, RECT SrcRect, float ScalingX, float ScalingY, float Degree);
	void _DrawFreeText(const string& Text, int x, int y, BYTE a, const string& Font, unsigned int Size, COLORREF Color, bool IsBold, bool IsItalic, float Degree);
	void _DrawRect(RECT Rect, COLORREF Color, BYTE a, float Degree);

	DrawManagerfD();										//ftHgRXgN^i֎~j
	DrawManagerfD(const DrawManagerfD&);					//Rs[RXgN^i֎~j
	DrawManagerfD& operator =(const DrawManagerfD&);		//Zqi֎~j
};

}
}
}
}

#endif
#endif