#include "stdafx.h"
#include "../../index.h"
#include "InputManagerfD.h"
#ifdef USE_ABYSSLIB

namespace nsDX9A{
namespace nsFramework{
namespace nsAbyssLib{
namespace nsInputManagerfD{

//RXgN^
InputManagerfD::InputManagerfD(DX9AInput* IM, DX9AGraphic* GM){
	m_IM = IM;
	m_GM = GM;
	ZeroMemory(&m_MouseCursorPos, sizeof(m_MouseCursorPos));
	m_MouseWheelPos = 0;
	ZeroMemory(MBIS, sizeof(MBIS));
	MBISIt = 0;
}

//͏XV
void InputManagerfD::Flush(){
	m_IM->Flush(m_GM->GetFullScreen());
	MBISIt = 1 - MBISIt;
	MBIS[0][MBISIt] = m_IM->GetMouseButton(0);
	MBIS[1][MBISIt] = m_IM->GetMouseButton(1);
	MBIS[2][MBISIt] = m_IM->GetMouseButton(2);
	m_IM->GetMousePos(m_MouseCursorPos);
	m_MouseWheelPos = m_IM->GetMouseWheel();
}
//Ԃ̗L
bool InputManagerfD::LButton() const{
	return(MBIS[0][MBISIt]);
}
//ꂽ΂肩H
bool InputManagerfD::PushLButton() const{
	return(MBIS[0][MBISIt] && !MBIS[0][1-MBISIt]);
}
//ꂽ΂肩H
bool InputManagerfD::PushUpLButton() const{
	return(!MBIS[0][MBISIt] && MBIS[0][1-MBISIt]);
}
//Ԃ̗L
bool InputManagerfD::MButton() const{
	return(MBIS[2][MBISIt]);
}
//ꂽ΂肩H
bool InputManagerfD::PushMButton() const{
	return(MBIS[2][MBISIt] && !MBIS[2][1-MBISIt]);
}
//ꂽ΂肩H
bool InputManagerfD::PushUpMButton() const{
	return(!MBIS[2][MBISIt] && MBIS[2][1-MBISIt]);
}
//Ԃ̗L
bool InputManagerfD::RButton() const{
	return(MBIS[1][MBISIt]);
}
//ꂽ΂肩H
bool InputManagerfD::PushRButton() const{
	return(MBIS[1][MBISIt] && !MBIS[1][1-MBISIt]);
}
//ꂽ΂肩H
bool InputManagerfD::PushUpRButton() const{
	return(!MBIS[1][MBISIt] && MBIS[1][1-MBISIt]);
}
//J[\W擾
void InputManagerfD::GetXY(int& x, int& y) const{
	x = m_MouseCursorPos.x;
	y = m_MouseCursorPos.y;
}
//zC[擾
void InputManagerfD::GetZ(int &z) const{
	z = m_MouseWheelPos;
}

}
}
}
}

#endif