/*************************************************
t@CFEffect.h
쐬ҁ@@Fт
@@@FGtFNg
*************************************************/
/**
*	@file	Effect.h
*	@brief	GtFNgNX֌WłB
*/
#ifndef DX9A_FRAME_EFFECT_H
#define DX9A_FRAME_EFFECT_H

namespace nsDX9A{
namespace nsFramework{
namespace nsEffect{

//GtFNgNXiC^[tF[Xj
/**
*	@brief	GtFNgNX̃C^[tF[XłB
*/
class IEffecter{
public:
/**
*	@brief	zfXgN^łB
*/
	virtual ~IEffecter(){}								//zfXgN^

/**
*	@brief	GtFNgJn܂B
*
*			GtFNgJn悤ɎĂB
*/
	virtual void Start() = 0;							//GtFNgJn
/**
*	@brief	GtFNgI܂B
*
*			GtFNgI悤ɎĂB
*/
	virtual void End() = 0;								//GtFNgI

/**
*	@brief	GtFNg̕`s܂B
*
*			GtFNg̕`s悤ɎĂB
*/
	virtual void OnDraw() = 0;							//`

/**
*	@brief	GtFNg擾܂B
*
*			GtFNg擾悤ɎĂB
*	@return	GtFNgԂ܂B<br>
*			GtFNg̏ꍇtrueAGtFNgłȂꍇfalseԂ܂B
*/
	virtual bool IsActive() const = 0;					//GtFNgH

/**
*	@brief	|[Y܂B
*
*			|[Y悤ɎĂB
*/
	virtual void Pause() = 0;							//|[Y
/**
*	@brief	|[Y܂B
*
*			|[Y悤ɎĂB
*/
	virtual void Restart() = 0;							//|[Y
/**
*	@brief	|[YԂ擾܂B
*
*			|[YԂԂ悤ɎĂB
*	@return	|[YԂԂ܂B<br>
*			|[YԂ̏ꍇtrueA|[YԂłȂꍇfalseԂ܂B
*/
	virtual bool IsPause() const = 0;					//|[YԂH
};

//GtFNgNXitF[hCj
/**
*	@brief	GtFNgNX̃tF[hCłB
*/
class cEffecterFadeIn : public IEffecter{
public:
/**
*	@brief	RXgN^łB
*	@param	GM	[in]֌W\link	nsDX9A::nsGraphics::nsDX9AGraphic::DX9AGraphic	DirectX Graphicsbp[NX\endlinkw肵܂B
*/
	cEffecterFadeIn(DX9AGraphic* GM);					//RXgN^

/**
*	@brief	GtFNg̃p[^ݒ肵܂B
*	@param	Color	[in]tF[hC̐Fw肵܂B
*	@param	Time	[in]tF[hČʎԁiPʁF~bjw肵܂B
*/
	void SetParam(COLORREF Color, DWORD Time);			//p[^ݒ

	void Start();										//GtFNgJn
	void End();											//GtFNgI

	void OnDraw();										//`

	bool IsActive() const;								//GtFNgH

	void Pause();										//|[Y
	void Restart();										//|[Y
	bool IsPause() const;								//|[YԂH
private:
	DX9AGraphic* m_GM;									//DirectX Graphicsbp[NXւ̃|C^
	COLORREF m_Color;									//ʐF
	DWORD m_Time;										//ʎ
	CTimer m_Timer;										//^C}
	bool m_IsActive;									//GtFNgH
};

//GtFNgNXitF[hAEgj
/**
*	@brief	GtFNgNX̃tF[hAEgłB
*/
class cEffecterFadeOut : public IEffecter{
public:
/**
*	@brief	RXgN^łB
*	@param	GM	[in]֌W\link	nsDX9A::nsGraphics::nsDX9AGraphic::DX9AGraphic	DirectX Graphicsbp[NX\endlinkw肵܂B
*/
	cEffecterFadeOut(DX9AGraphic* GM);					//RXgN^

/**
*	@brief	GtFNg̃p[^ݒ肵܂B
*	@param	Color	[in]tF[hAEg̐Fw肵܂B
*	@param	Time	[in]tF[hAEǧʎԁiPʁF~bjw肵܂B
*/
	void SetParam(COLORREF Color, DWORD Time);			//p[^ݒ

	void Start();										//GtFNgJn
	void End();											//GtFNgI

	void OnDraw();										//`

	bool IsActive() const;								//GtFNgH

	void Pause();										//|[Y
	void Restart();										//|[Y
	bool IsPause() const;								//|[YԂH
private:
	DX9AGraphic* m_GM;									//DirectX Graphicsbp[NXւ̃|C^
	COLORREF m_Color;									//ʐF
	DWORD m_Time;										//ʎ
	CTimer m_Timer;										//^C}
	bool m_IsActive;									//GtFNgH
};

//GtFNgNXiAj[VGtFNgj
/**
*	@brief	GtFNgNX̃Aj[VGtFNgłB
*/
class cEffecterAnimation : public IEffecter{
public:
/**
*	@brief	RXgN^łB
*	@param	GM		[in]֌W\link	nsDX9A::nsGraphics::nsDX9AGraphic::DX9AGraphic	DirectX Graphicsbp[NX\endlinkw肵܂B
*	@param	PM		[in]֌W\link	nsDX9A::nsFramework::nsParam::DX9AParam	p[^ǗNX\endlinkw肵܂B
*	@param	Helper	[in]OtBbNǂݍ݂ɗp\link	nsDX9A::nsFramework::nsIDraw2DHelper::IDraw2DHelper	OtBbNǗNXi2Dj̃wp[NX\endlinkw肵܂B
*/
	cEffecterAnimation(DX9AGraphic* GM, DX9AParam* PM, IDraw2DHelper* Helper);
														//RXgN^

/**
*	@brief	GtFNg̃p[^ݒ肵܂B
*
*			Aj[Ṽp^[𒼐ڐݒ肷邱Ƃ\łB
*	@param	AnimPattern	[in]Aj[Ṽp^[w肵܂B<br>
*						́Avector<pair<t@C, ]`>>ƂȂ܂B
*	@param	BaseScaling	[in]Aj[V̊{gkw肵܂B
*	@param	WaitTime	[in]eR}Ԃ̃EFCgw肵܂iPʁF~bj
*/
	void SetParam(const vector< pair<string, RECT> >& AnimPattern, float BaseScaling = 1.0, DWORD WaitTime = 16);
														//p[^ݒiڎwj
/**
*	@brief	GtFNg̃p[^ݒ肵܂B
*
*			Aj[Ṽp^[ݒt@CĐݒ肷邱Ƃ\łB<br>
*			ݒt@C̋̓IȋLq@́ASampleEffect.iniQƂĂB
*	@param	INIFileName	[in]Aj[Ṽp^[Lqݒt@Cw肵܂B
*/
	void SetParam(const string& INIFileName);			//p[^ݒiݒt@Cwj
/**
*	@brief	GtFNg̕\Wݒ肵܂B
*	@param	X			[in]wWw肵܂B
*	@param	Y			[in]xWw肵܂B
*	@param	IsCenter	[in]W̊w肵܂B<br>
*						wxW摜̒ɂꍇtrueA摜̍ɂꍇfalsew肵܂B
*/
	void SetPosition(int X, int Y, bool IsCenter = false);
														//\Wݒ
/**
*	@brief	݂̊gkݒ肵܂B
*
*			\GtFNg̊gḱi{gkj~i݂̊gkjƂȂ܂B
*	@param	NowScaling	[in]݂̊gkw肵܂B
*/
	void SetNowScaling(float NowScaling);				//݂̊gkݒ
/**
*	@brief	݂̉]pxݒ肵܂B
*	@param	Degree	[in]]pxw肵܂iPʁFxj
*/
	void SetDegree(float Degree);						//]pxݒ

	void Start();										//GtFNgJn
	void End();											//GtFNgI

	void OnDraw();										//`

	bool IsActive() const;								//GtFNgH

	void Pause();										//|[Y
	void Restart();										//|[Y
	bool IsPause() const;								//|[YԂH
private:
	int m_X, m_Y;										//GtFNg̔ʒu
	bool m_IsCenter;									//W̊itrueF摜̒AfalseF摜̍j
	float m_NowScaling;									//݂̊gk
	float m_Degree;										//]px
	cSprite m_EffectSprite;								//XvCg
};

//GtFNgvZXNX
/**
*	@brief	GtFNgsvZXNXłB
*
*			GtFNgsAsIɉL̉ꂩ̓s܂B<br>
*			EvZXiɎsvZXNXjݒ肳Ăꍇ́AsvZX؂ւ܂B<br>
*			EvZXiɎsvZXNXjݒ肳ĂȂꍇ́AvZX̉s܂B
*/
class CEffectProcess : public nsDX9A::nsFramework::nsProcess::CProcess{
public:
/**
*	@brief	RXgN^łB
*	@param	Manager	[in]\link	nsDX9A::nsFramework::nsProcess::DX9AProcess	vZXǗNX\endlinkw肵܂B
*	@param	ClassID	[in]{NX̃NXhcw肵܂B<br>
*					NX̎ޖ0ȏ̈ӂȒlw肵ĂB
*/
	CEffectProcess(DX9AProcess* Manager, int ClassID);	//RXgN^
/**
*	@brief	fXgN^łB
*/
	~CEffectProcess();									//fXgN^

	void Release();										//

	void Init();										//

	void OnBegin();										//vZXsiOj
	void OnMove(){}										//vZXsi{j
	void OnDraw();										//vZXsi`j
	void OnEnd();										//vZXsi㏈j

	void Pause();										//|[Y
	void Restart();										//|[Y
	bool IsPause() const;								//|[YԂH

/**
*	@brief	GtFNgݒ肵܂B
*	@param	Effect	[in]sGtFNgNXw肵܂B
*/
	void SetEffect(IEffecter* Effect);					//GtFNgݒ
private:
	IEffecter* m_Effect;								//GtFNgNX
	bool m_IsStartEffect;								//GtFNgJnꂽH

	CEffectProcess();									//ftHgRXgN^i֎~j
	CEffectProcess(const CEffectProcess&);				//Rs[RXgN^i֎~j
	CEffectProcess& operator =(const CEffectProcess&);	//Zqi֎~j
};

}
}
}

#endif