/*************************************************
t@CFFilePack.h
쐬ҁ@@Fт
@@@Ft@CpbN
*************************************************/
/**
*	@file	FilePack.h
*	@brief	t@CpbN֌WłB
*
*			t@CpbNǗNXƃt@CpbNt@C͂sNX݂܂B
*/
#ifndef DX9A_FRAME_FILEPACK_H
#define DX9A_FRAME_FILEPACK_H

namespace nsDX9A{
namespace nsFramework{
namespace nsFilePack{

//O錾
class DX9AFilePack;

//t@C
/**
*	@brief	pbNꂽt@C̏񂪊i[Ă\̂łB<br>
*			[U[gpKv͂܂B
*/
struct PackedFileData{
/**
*	@brief	pbNꂽt@C̈ʒui[Ă܂B
*/
	fpos_t FilePos;																//t@C̈ʒu
/**
*	@brief	pbNꂽt@C̃TCYi[Ă܂B
*/
	long FileSize;																//t@C̃TCY
};

//t@CpbÑwb_
/**
*	@brief	t@CpbÑwb_񂪊i[Ă\̂łB<br>
*			[U[gpKv͂܂B
*/
struct FilePackHeader{
/**
*	@brief	X̃pbNꂽt@C̏񂪊i[Ă܂B
*/
	map<string, PackedFileData> FileData;										//t@Cƃt@C
};

//t@C̓NXit@CpbNΉŁj
/**
*	@brief	\link	nsDX9A::nsFile::nsFileReader::IFileReader	t@C̓NX\endlink̃t@CpbNΉłłB
*/
class CFilePackReader : public nsDX9A::nsFile::nsFileReader::CFileReader{
public:
/**
*	@brief	RXgN^łB
*	@param	Manager			[in]֌W\link	DX9AFilePack	t@CpbNǗNX\endlinkw肵܂B
*	@param	FilePackName	[in]gpt@CpbNw肵܂B
*/
	CFilePackReader(DX9AFilePack* Manager, const string& FilePackName);			//RXgN^it@CpbNǗNXAt@CpbNwj
/**
*	@brief	RXgN^łB
*	@param	Manager			[in]֌W\link	DX9AFilePack	t@CpbNǗNX\endlinkw肵܂B
*	@param	FilePackName	[in]gpt@CpbNw肵܂B
*	@param	FileName		[in]I[vt@Cw肵܂B
*	@param	Mode			[in]t@C[hw肵܂B
*/
	CFilePackReader(DX9AFilePack* Manager, const string& FilePackName, const char* FileName, const char* Mode);
																				//RXgN^it@CpbNǗNXAt@CpbNAt@CA[hwj

	bool fopen(const char* FileName, const char* Mode);							//fopen
	long fsize();																//fsize

	bool fgetc(char* c);														//fgetc
	bool fgets(char* s, int n);													//fgets
	size_t fread(void* buffer, size_t size, size_t count);						//fread

	long ftell();																//ftell
	bool fseek(long offset, int origin);										//fseek
	bool fgetpos(fpos_t* pos);													//fgetpos
	bool fsetpos(const fpos_t* pos);											//fsetpos

	bool feof();																//feof
private:
	string m_FilePackName;														//t@CpbN
	PackedFileData m_FileData;													//t@CiPjiI[vĂt@Cj
	const FilePackHeader& m_FileDatas;											//t@Cijit@CpbN̑St@Cj

	CFilePackReader();															//ftHgRXgN^i֎~j
	CFilePackReader(const CFilePackReader&);									//Rs[RXgN^i֎~j
	CFilePackReader& operator =(const CFilePackReader&);						//Zqi֎~j
};

//t@CpbNǗNX
/**
*	@brief	t@CpbNǗsNXłB
*/
class DX9AFilePack{
/**
*	@brief	CFilePackReader	NX{NX̃vCx[goɃANZX\łB
*/
	friend class CFilePackReader;												//thNX
public:
/**
*	@brief	RXgN^łB
*	@param	FileReader	[in]gp\link	nsDX9A::nsFile::nsFileReader::IFileReader	t@C̓NX\endlinkw肵܂B
*	@param	FileWriter	[in]gp\link	nsDX9A::nsFile::nsFileWriter::IFileWriter	t@Co̓NX\endlinkw肵܂B
*/
	DX9AFilePack(IFileReader* FileReader, IFileWriter* FileWriter);				//RXgN^it@C̓NXAt@Co̓NXwj
/**
*	@brief	fXgN^łB
*/
	~DX9AFilePack();															//zfXgN^

/**
*	@brief	ÍL[ݒ肵܂B
*			ÍASYXORÍłB
*	@param	Key	[in]ÍL[w肵܂B
*/
	void SetCryptKey(BYTE Key);													//ÍL[ݒ
/**
*	@brief	\link	nsDX9A::nsFile::nsFileReader::IFileReader	t@C̓NX\endlinkݒ肵܂B
*	@param	FileReader	[in]\link	nsDX9A::nsFile::nsFileReader::IFileReader	t@C̓NX\endlinkw肵܂B
*/
	void SetFileReader(IFileReader* FileReader);								//t@C̓NXݒ
/**
*	@brief	\link	nsDX9A::nsFile::nsFileWriter::IFileWriter	t@Co̓NX\endlinkݒ肵܂B
*	@param	FileWriter	[in]\link	nsDX9A::nsFile::nsFileWriter::IFileWriter	t@Co̓NX\endlinkw肵܂B
*/
	void SetFileWriter(IFileWriter* FileWriter);								//t@Co̓NXݒ

/**
*	@brief	t@CpbNI[v܂B
*	@param	FilePackName	[in]t@CpbNw肵܂B
*/
	bool OpenFilePack(const string& FilePackName);								//t@CpbNJ
/**
*	@brief	t@CpbNN[Y܂B
*	@param	FilePackName	[in]t@CpbNw肵܂B
*/
	void CloseFilePack(const string& FilePackName);								//t@CpbN
/**
*	@brief	Ώۂ̃tH_Ƀt@CpbLOsAt@CpbN쐬܂B
*
*			t@CpbLOɁAΏۃtH_init@C`datt@C`ɈÖٓIɕϊ܂B<br>
*			āA{\bhsOɑΏۂ̃tH_obNAbvĂĂB
*	@param	TargetDirectory	[in]Ώۂ̃tH_w肵܂B
*	@param	DX9AP			[in]init@C`datt@C`ɕϊ̂Ɏgp\link	nsDX9A::nsFramework::nsParam::DX9AParam	p[^ǗNX\endlinkw肵܂B
*	@return	t@CpbLOɐꍇtrueAsꍇfalseԂ܂B
*/
	bool ConvertToFilePack(const string& TargetDirectory, DX9AParam& DX9AP);	//ΏۂpbLO
private:
	BYTE m_CryptKey;															//ÍL[
	IFileReader* m_FileReader;													//t@C̓NX
	IFileWriter* m_FileWriter;													//t@Co̓NX
	map<string, FilePackHeader> m_FilePacks;									//t@CpbÑwb_

	DX9AFilePack();																//ftHgRXgN^i֎~j
	DX9AFilePack(const DX9AFilePack&);											//Rs[RXgN^i֎~j
	DX9AFilePack& operator =(const DX9AFilePack&);								//Zqi֎~j
};

}
}
}

#endif