/*************************************************
t@CFDX9AGraphic.h
쐬ҁ@@Fт
@@@FDirectX Graphicsbp[
*************************************************/
/**
*	@file	DX9AGraphic.h
*	@brief	DirectX Graphics̃bp[NX֌WłB
*/
#ifndef DX9A_GRAPHICS_DX9AGRAPHIC_H
#define DX9A_GRAPHICS_DX9AGRAPHIC_H

namespace nsDX9A{
namespace nsGraphics{
namespace nsDX9AGraphic{

//eNX`
/**
*	@brief	eNX`̏񂪊i[Ă\̂łB<br>
*			[U[gpKv͂܂B
*/
struct StringTexture{
/**
*	@brief	eNX`ŌɎQƂꂽԂłB
*/
	DWORD LastRefTime;																		//ŌɎQƂꂽ
/**
*	@brief	eNX`̃TCYłiPʁFoCgj
*/
	unsigned int Size;																		//eNX`̃TCY
/**
*	@brief	eNX`̉łB
*/
	unsigned int Width;																		//eNX`̉
/**
*	@brief	eNX`̏cłB
*/
	unsigned int Height;																	//eNX`̏c
/**
*	@brief	eNX`łi<a href="http://msdn.microsoft.com/ja-jp/library/cc324033.aspx" target="_blank">IDirect3DTexture9C^[tFCX</a>ւ̃|C^j
*/
	LPDIRECT3DTEXTURE9 Texture;																//eNX`
};

//DirectX Graphicsbp[
/**
*	@brief	DirectX Graphics̃bp[NXłB<br>
*			gpOɁAKInit\bhsĂB
*/
class DX9AGraphic{
/**
*	@brief	DX9AGraphicAccessor	NX{NX̃vCx[goɃANZX\łB
*/
	friend class DX9AGraphicAccessor;														//thNXiANZbTj
public:
/**
*	@brief	ftHgRXgN^łB
*/
	DX9AGraphic();																			//ftHgRXgN^
/**
*	@brief	fXgN^łB
*/
	~DX9AGraphic();																			//fXgN^

	//iKĂяoƁj
/**
*	@brief	s܂B<br>
*			gpOɁAKsĂB
*	@param	hInst					[in]CX^Xnhw肵܂B
*	@param	WindowName				[in]EChEw肵܂B
*	@param	WndProc					[in]bZ[WpR[obN֐w肵܂B
*	@param	ScreenWidth				[in]EChẺw肵܂B
*	@param	ScreenHeight			[in]EChȄcw肵܂B
*	@param	StringTextureMaxSize	[in]eNX`̍őTCYw肵܂iPʁFoCgj<br>
*									Ŋgꍇ܂B<br>
*									iFStringTextureMaxSize = 5 * 1024i5KBjŎgp̕eNX`i6KBj݂ꍇA<br>
*									@@@StringTextureMaxSize = 6 * 1024i6KBjɎŊg܂j
*	@param	IsFullScreen			[in]tXN[[hw肵܂B<br>
*									tXN[[hɂꍇtrueAEChE[hɂꍇfalsew肵܂B
*	@param	UseDepthStencil			[in][x^XeVobt@gp邩w肵܂B<br>
*									gpꍇtrueAgpȂꍇfalsew肵܂B
*	@param	UseMultiSample			[in]tV[A`GCAVOgp邩w肵܂B<br>
*									gpꍇtrueAgpȂꍇfalsew肵܂B
*	@param	hIcon					[in]ACRw肵܂B
*	@param	hCursor					[in]}EXJ[\w肵܂B
*	@param	hIconSm					[in]ACRw肵܂B
*	@return	ꍇtrueAsꍇfalseԂ܂B
*/
	bool Init(HINSTANCE hInst, LPCTSTR WindowName, WNDPROC WndProc, int ScreenWidth, int ScreenHeight, unsigned int StringTextureMaxSize, 
			  bool IsFullScreen = false, bool UseDepthStencil = false, bool UseMultiSample = false, HICON hIcon = NULL, HCURSOR hCursor = NULL, HICON hIconSm = NULL);

	//ACh̏iKs邱Ɓj
/**
*	@brief	ACh̏s܂B<br>
*			C[vŁAKsĂB
*	@return	ꍇtrueAsꍇfalseԂ܂B
*/
	bool AppIdle();

	//EChEvV[WiKs邱Ɓj
/**
*	@brief	EChEvV[Wł̏s܂B<br>
*			EChEvV[WŁAKsĂB
*	@param	hWnd	[in]EChEvV[WhWndw肵܂B<br>
*	@param	uMsg	[in]EChEvV[WuMsgw肵܂B
*	@param	wParam	[in]EChEvV[WwParamw肵܂B
*	@param	lParam	[in]EChEvV[WlParamw肵܂B
*/
	void MsgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	//̑iς܂ĂĂяoƁj
/**
*	@brief	ANeBuԂ擾܂B
*	@return	ANeBuԂԂ܂B<br>
*			ANeBuԂ̏ꍇtrueAANeBuԂłȂꍇfalseԂ܂B
*/
	bool IsActive() const;																	//ANeBuԂ擾

/**
*	@brief	EChEnh擾܂B
*	@return	EChEnhԂ܂B
*/
	HWND GetHWND() const;																	//EChEnh擾

/**
*	@brief	EChẺ擾܂B
*	@return	EChẺԂ܂B
*/
	int GetScreenWidth() const;																//ʂ̉擾
/**
*	@brief	EChȄc擾܂B
*	@return	EChȄcԂ܂B
*/
	int GetScreenHeight() const;															//ʂ̏c擾
/**
*	@brief	tXN[擾܂B
*	@return	tXN[Ԃ܂B<br>
*			tXN[[h̏ꍇtrueAEChE[h̏ꍇfalseԂ܂B
*/
	bool GetFullScreen() const;																//tXN[[hۂ擾
/**
*	@brief	tXN[ݒ肵܂B
*	@param	IsFullScreen	[in]tXN[w肵܂B<br>
*							tXN[[hɂꍇtrueAEChE[hɂꍇfalsew肵܂B
*/
	bool SetFullScreen(bool IsFullScreen);													//tXN[[hۂݒ

/**
*	@brief	ʂ̏s܂B
*	@param	Color	[in]hׂF<a href="http://msdn.microsoft.com/ja-jp/library/bb172518(v=vs.85).aspx" target="_blank">D3DCOLOR</a>Ŏw肵܂B
*/
	void Clear(D3DCOLOR Color);																//ʂ

/**
*	@brief	ʂ̍XVs܂B
*/
	void Present();																			//ʂXV

/**
*	@brief	`̕`s܂B
*	@param	Rect		[in]`<a href="http://msdn.microsoft.com/ja-jp/library/ms931125.aspx" target="_blank">RECT</a>Ŏw肵܂B
*	@param	Color		[in]hׂF<a href="http://msdn.microsoft.com/ja-jp/library/bb172518(v=vs.85).aspx" target="_blank">D3DCOLOR</a>Ŏw肵܂B
*	@param	Degree		[in]]pxw肵܂iPʁFxj
*	@param	BlendOp		[in]ufBO<a href="http://msdn.microsoft.com/ja-jp/library/bb172509(VS.85).aspx" target="_blank">D3DBLENDOP</a>Ŏw肵܂B
*	@param	SrcBlend	[in]]̃ufBO[h<a href="http://msdn.microsoft.com/ja-jp/library/cc324307.aspx" target="_blank">D3DBLEND</a>Ŏw肵܂B
*	@param	DestBlend	[in]]̃ufBO[h<a href="http://msdn.microsoft.com/ja-jp/library/cc324307.aspx" target="_blank">D3DBLEND</a>Ŏw肵܂B
*/
	void DrawRect(RECT Rect, D3DCOLOR Color, float Degree = 0.0f, D3DBLENDOP BlendOp = D3DBLENDOP_ADD, D3DBLEND SrcBlend = D3DBLEND_SRCALPHA, D3DBLEND DestBlend = D3DBLEND_INVSRCALPHA);
																							//``
/**
*	@brief	̕`s܂B
*	@param	Text		[in]w肵܂B
*	@param	x			[in]̕`XWw肵܂B
*	@param	y			[in]̕`YWw肵܂B
*	@param	Color		[in]̐F<a href="http://msdn.microsoft.com/ja-jp/library/bb172518(v=vs.85).aspx" target="_blank">D3DCOLOR</a>Ŏw肵܂B
*	@param	Font		[in]̃tHgw肵܂B
*	@param	Size		[in]̃TCYw肵܂B
*	@param	IsBold		[in]񂪑w肵܂B<br>
*						̏ꍇtrueAłȂꍇfalsew肵܂B
*	@param	IsItalic	[in]񂪎Α̂w肵܂B<br>
*						Α̂̏ꍇtrueAΑ̂łȂꍇfalsew肵܂B
*	@param	Degree		[in]]pxw肵܂iPʁFxj
*	@param	BlendOp		[in]ufBO<a href="http://msdn.microsoft.com/ja-jp/library/bb172509(VS.85).aspx" target="_blank">D3DBLENDOP</a>Ŏw肵܂B
*	@param	SrcBlend	[in]]̃ufBO[h<a href="http://msdn.microsoft.com/ja-jp/library/cc324307.aspx" target="_blank">D3DBLEND</a>Ŏw肵܂B
*	@param	DestBlend	[in]]̃ufBO[h<a href="http://msdn.microsoft.com/ja-jp/library/cc324307.aspx" target="_blank">D3DBLEND</a>Ŏw肵܂B
*/
	void DrawFreeText(const string& Text, int x, int y, D3DCOLOR Color, const string& Font, unsigned int Size, bool IsBold, bool IsItalic, float Degree = 0.0f, D3DBLENDOP BlendOp = D3DBLENDOP_ADD, D3DBLEND SrcBlend = D3DBLEND_SRCALPHA, D3DBLEND DestBlend = D3DBLEND_INVSRCALPHA);
																							//`
/**
*	@brief	eNX`̓]s܂B
*	@param	Texture		[in]Ώۂ̃eNX`w肵܂B
*	@param	x			[in]eNX`̕`XWw肵܂B
*	@param	y			[in]eNX`̕`YWw肵܂B
*	@param	Color		[in]eNX`̕`F<a href="http://msdn.microsoft.com/ja-jp/library/bb172518(v=vs.85).aspx" target="_blank">D3DCOLOR</a>Ŏw肵܂B
*	@param	SrcRect		[in]]`<a href="http://msdn.microsoft.com/ja-jp/library/ms931125.aspx" target="_blank">RECT</a>Ŏw肵܂B
*	@param	BlendOp		[in]ufBO<a href="http://msdn.microsoft.com/ja-jp/library/bb172509(VS.85).aspx" target="_blank">D3DBLENDOP</a>Ŏw肵܂B
*	@param	SrcBlend	[in]]̃ufBO[h<a href="http://msdn.microsoft.com/ja-jp/library/cc324307.aspx" target="_blank">D3DBLEND</a>Ŏw肵܂B
*	@param	DestBlend	[in]]̃ufBO[h<a href="http://msdn.microsoft.com/ja-jp/library/cc324307.aspx" target="_blank">D3DBLEND</a>Ŏw肵܂B
*	@param	ScalingX	[in]g{iXjw肵܂B
*	@param	ScalingY	[in]g{iYjw肵܂B
*	@param	Degree		[in]]pxw肵܂iPʁFxj
*/
	void GeneralBlt(LPDIRECT3DTEXTURE9 Texture, int x, int y, D3DCOLOR Color, const RECT* SrcRect, D3DBLENDOP BlendOp, D3DBLEND SrcBlend, D3DBLEND DestBlend, float ScalingX = 1.0f, float ScalingY = 1.0f, float Degree = 0.0f);
																							//ėp]
private:
	HWND m_hWnd;																			//EChEnh
	HINSTANCE m_hInst;																		//CX^Xnh
	string m_ClassName;																		//EChENX̖O
	bool m_IsActive;																		//ANeBuԂH
	bool m_IsBeginScene;																	//V[JnĂ邩H
	bool m_IsBeginSprite;																	//XvCg̕`悪JnĂ邩H
	bool m_IsDeviceLost;																	//foCXĂ邩H
	int  m_ScreenWidth;																		//ʂ̉
	int  m_ScreenHeight;																	//ʂ̏c
	bool m_IsFullScreen;																	//tXN[[hH
	bool m_IsUseDepthStencil;																//[x^XeVobt@gp邩H
	bool m_IsUseMultiSample;																//tV[A`GCAVOgp邩H
	RECT m_WindowLastPos;																	//EChE̍Ō̈ʒu

	void BeginScene();																		//`Jn
	void EndScene();																		//`I

	void BeginSprite();																		//XvCg̕`Jn
	void EndSprite();																		//XvCg̕`I

	bool InitApp(LPCTSTR WindowName, WNDPROC WndProc, HICON hIcon, HCURSOR hCursor, HICON hIconSm);
																							//AvP[V
	bool InitD3D();																			//Direct3DɊǗĂIuWFNg
	bool SelectD3DDevice(UINT& Adapter, D3DDEVTYPE& Device);								//foCX̐ݒI
	bool CheckDeviceCaps(D3DCAPS9* Caps);													//foCX̔\͂`FbN
	bool SelectAdapterFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE DMode);		//fBXvCƃobNobt@̃tH[}bg𒲍
	bool SelectDepthStencilFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE DMode);	//[x^XeVobt@̃tH[}bg𒲍
	bool SelectRenderTextureFormat(UINT Adapter, D3DDEVTYPE Device, D3DDISPLAYMODE DMode);	//_OeNX`̃tH[}bg𒲍
	bool SelectMultiSampleType(UINT Adapter, D3DDEVTYPE Device);							//tV[A`GCAVO𒲍
	bool SelectDisplayMode(UINT Adapter);													//fBXvC[h𒲍
	bool InitD3DObject();																	//Direct3DɊǗĂȂIuWFNg

	bool CleanupD3DObject();																//Direct3DɊǗĂȂIuWFNg̏I
	bool CleanupD3D();																		//Direct3DɊǗĂIuWFNg̏I
	bool CleanupApp();																		//AvP[V̏I

	LPDIRECT3D9 m_pD3D;																		//Direct3D9IuWFNg
	LPDIRECT3DDEVICE9 m_pD3DDevice;															//Direct3DDevice9IuWFNg
	D3DPRESENT_PARAMETERS m_D3DParamNow;													//D3DPRESENT_PARAMETERS\́i݁j
	D3DPRESENT_PARAMETERS m_D3DParamWin;													//D3DPRESENT_PARAMETERS\́iEChE[hj
	D3DPRESENT_PARAMETERS m_D3DParamFull;													//D3DPRESENT_PARAMETERS\́itXN[[hj
	D3DFORMAT m_FmtRenderTextureWin;														//_OeNX`̃tH[}bgiEChE[hj
	D3DFORMAT m_FmtRenderTextureFull;														//_OeNX`̃tH[}bgitXN[[hj

	LPD3DXSPRITE m_pD3DXSprite;																//XvCg
	LPDIRECT3DTEXTURE9 m_pDrawRect;															//``peNX`

	unsigned int m_StringTextureNowSize;													//eNX`̍vTCY
	unsigned int m_StringTextureMaxSize;													//eNX`̍őTCY
	map<string, StringTexture> m_StringTexture;												//eNX`i<"eLXg_tHg_TCY_̑", eNX`\>j

	DX9AGraphic(const DX9AGraphic&);														//Rs[RXgN^i֎~j
	DX9AGraphic& operator =(const DX9AGraphic&);											//Zqi֎~j
};

//DirectX Graphicsbp[ւ̃ANZbT
/**
*	@brief	DX9AGraphic	NXւ̃ANZbTNXłB<br>
*			gpOɁAKSetParent\bhsĂB<br>
*			܂ÃNXoR	DX9AGraphic	NX̃vCx[go𑀍삷̂͑ϊ댯ȍsׂłB<br>
*			𗝉A\ӂŎgp悤ɂĂB
*/
class DX9AGraphicAccessor{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	DX9AGraphicAccessor();																	//ftHgRXgN^

/**
*	@brief	ANZXΏۂ	DX9AGraphic	NXݒ肵܂B
*	@param	Parent	[in]ANZXΏۂ	DX9AGraphic	NXw肵܂B
*/
	void SetParent(DX9AGraphic* Parent);													//eGWݒ

/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/cc324302.aspx" target="_blank">IDirect3D9C^[tFCXւ̃|C^</a>擾܂B
*	@return	<a href="http://msdn.microsoft.com/ja-jp/library/cc324302.aspx" target="_blank">IDirect3D9C^[tFCXւ̃|C^</a>Ԃ܂B
*/
	LPDIRECT3D9 GetD3D9();																	//Direct3D9IuWFNg擾
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/cc372361.aspx" target="_blank">ID3DXSpriteC^[tFCXւ̃|C^</a>擾܂B
*	@return	<a href="http://msdn.microsoft.com/ja-jp/library/cc372361.aspx" target="_blank">ID3DXSpriteC^[tFCXւ̃|C^</a>Ԃ܂B
*/
	LPD3DXSPRITE GetD3DXSprite();															//XvCgIuWFNg擾
/**
*	@brief	<a href="http://msdn.microsoft.com/ja-jp/library/cc324252.aspx" target="_blank">IDirect3DDevice9C^[tFCXւ̃|C^</a>擾܂B
*	@return	<a href="http://msdn.microsoft.com/ja-jp/library/cc324252.aspx" target="_blank">IDirect3DDevice9C^[tFCXւ̃|C^</a>Ԃ܂B
*/
	LPDIRECT3DDEVICE9 GetD3D9Device();														//Direct3DDevice9IuWFNg擾
private:
	DX9AGraphic* Outer;																		//eGW̃AhX

	DX9AGraphicAccessor(const DX9AGraphicAccessor&);										//Rs[RXgN^i֎~j
	DX9AGraphicAccessor& operator =(const DX9AGraphicAccessor&);							//Zqi֎~j
};

//ANZbT擾
/**
*	@brief	DX9AGraphicAccessor	NX擾܂B
*	@param	Parent	[in]ANZXΏۂ	DX9AGraphic	NXw肵܂B
*	@return	DX9AGraphicAccessor	NXւ̃|C^Ԃ܂B
*/
DX9AGraphicAccessor* GetDX9AGraphicAccessor(DX9AGraphic* Parent);

}
}
}

#endif