#include "stdafx.h"
#include "index.h"
#include "ScriptPlayer2.h"

//ÓIϐ
BaseIOStream s_Stream;

//O[oϐ
DX9AInput g_DXProjectInput;
DX9ASound g_DXProjectSound;
DX9AGraphic g_DXProjectGraphics;

LRESULT CALLBACK MsgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	g_DXProjectGraphics.MsgProc(hWnd, uMsg, wParam, lParam);
	switch(uMsg){
		case(WM_CLOSE):
			if(MessageBox(g_DXProjectGraphics.GetHWND(), "I܂H", "mF", MB_YESNO)==IDYES){
				DestroyWindow(g_DXProjectGraphics.GetHWND());
			}
			return(0);
			break;
		case(WM_DESTROY):
			PostQuitMessage(0);
			return(0);
			break;
		case(WM_SYSKEYDOWN):
			if(wParam==VK_MENU){
				return(0);
			}
			break;
	}
	return(DefWindowProc(hWnd, uMsg, wParam, lParam));
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow){

	//dN`FbN
	CMutex Mutex;
	if(!Mutex.Check(APP_TITLE)){
		MessageBox(NULL, "dN͋֎~Ă܂I", "G[I", MB_OK | MB_ICONWARNING);
		return(0);
	}
	//XNvgt@C`FbN
	if(!FindScriptFile(&s_Stream, FILE_SCRIPT)){
		MessageBox(NULL, FILE_SCRIPT"̓ǂݍ݂Ɏs܂I", "G[I", MB_OK | MB_ICONWARNING);
		return(0);
	}
	//DirectX
	if(!g_DXProjectGraphics.Init(hInstance, APP_TITLE, MsgProc, SCREEN_WIDTH, SCREEN_HEIGHT, 10 * 1024 * 1024, LoadEIsFullScreen(&s_Stream, DEFAULT_FILE_ENVIRONMENT))){
		MessageBox(g_DXProjectGraphics.GetHWND(), "DirectX Graphics̏Ɏs܂I", "G[I", MB_OK | MB_ICONWARNING);
		DX9AErrOut("Failed : DX9AGraphic::Init\n");
		return(0);
	}
	if(!g_DXProjectSound.Init(g_DXProjectGraphics.GetHWND())){
		MessageBox(g_DXProjectGraphics.GetHWND(), "DirectSound̏Ɏs܂I", "G[I", MB_OK | MB_ICONWARNING);
		DX9AErrOut("Failed : DX9ASound::Init\n");
		DestroyWindow(g_DXProjectGraphics.GetHWND());
		return(0);
	}
	if(!g_DXProjectInput.Init(hInstance, g_DXProjectGraphics.GetHWND())){
		MessageBox(g_DXProjectGraphics.GetHWND(), "DirectInput̏Ɏs܂I", "G[I", MB_OK | MB_ICONWARNING);
		DX9AErrOut("Failed : DX9AInput::Init\n");
		DestroyWindow(g_DXProjectGraphics.GetHWND());
		return(0);
	}
	//mxGW
	LoadPlugin();
	NovelPlayerfD ScriptPlayer(	g_DXProjectGraphics.GetHWND(), 
								new FileTextStream, 
								new InputManagerfD(&g_DXProjectInput, &g_DXProjectGraphics), 
								new SoundManagerfD(&g_DXProjectSound), 
								new DrawManagerfD(&g_DXProjectGraphics, DEFAULT_COLORKEY), 
								IT_ALLOW_ALL ); 
	LoadSettingsFromFile(&ScriptPlayer, &s_Stream);
	if(!ScriptPlayer.LoadScript(FILE_SCRIPT, &s_Stream)){
		MessageBox(g_DXProjectGraphics.GetHWND(), FILE_SCRIPT"̓ǂݍ݂Ɏs܂I", "G[I", MB_OK | MB_ICONWARNING);
		DX9AErrOut("Failed : NovelPlayerfD::LoadScript\n");
		DestroyWindow(g_DXProjectGraphics.GetHWND());
		return(0);
	}

	//bZ[W[v
	MSG msg;
	do{
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else{
			//ACh
			if(!g_DXProjectGraphics.AppIdle()){
				//G[FAvP[VI
				MessageBox(g_DXProjectGraphics.GetHWND(), "foCXł܂I", "G[I", MB_OK | MB_ICONWARNING);
				DX9AErrOut("Failed : DX9AGraphic::AppIdle\n");
				DestroyWindow(g_DXProjectGraphics.GetHWND());
			}
			else{
				//XNvgs
				ScriptPlayer.Run();
				//XNvg~ɂ͋I
				if(ScriptPlayer.GetState()==ST_SUSPEND){
					MessageBox(g_DXProjectGraphics.GetHWND(), "mxGW̓삪~܂I", "I", MB_OK | MB_ICONWARNING);
					DestroyWindow(g_DXProjectGraphics.GetHWND());
				}
			}
		}
	}while(msg.message!=WM_QUIT);

	SaveSettingsToFile(&ScriptPlayer, &s_Stream);
	FreeCommand(&ScriptPlayer);
	FreePlugin();
	return(static_cast<int>(msg.wParam));
}