/*************************************************
t@CFIDraw2DHelper.h
쐬ҁ@@Fт
@@@FOtBbNǗNXi2Dj̃wp[
*************************************************/
/**
*	@file	IDraw2DHelper.h
*	@brief	OtBbNǗNXi2Dj̃wp[֌WłB
*/
#ifndef DX9A_FRAME_IDRAW2DHELPER_H
#define DX9A_FRAME_IDRAW2DHELPER_H

namespace nsDX9A{
namespace nsFramework{
namespace nsIDraw2DHelper{

//OtBbNǗNXi2Dj̃wp[NX
/**
*	@brief	OtBbNǗNXi2Dj̃wp[NXłB
*
*			OtBbNǗNXi2Dj舵₷NXłB<br>
*			t@Cw肷邾ŁA摜t@Cǂݍ񂾂胁肵܂B
*/
class IDraw2DHelper{
public:
/**
*	@brief	RXgN^łB
*	@param	GM				[in]֌W\link	nsDX9A::nsGraphics::nsDX9AGraphic::DX9AGraphic	DirectX Graphicsbp[NX\endlinkw肵܂B
*	@param	ColorKey		[in]F<a href="http://msdn.microsoft.com/ja-jp/library/bb172518(v=vs.85).aspx" target="_blank">D3DCOLOR</a>Ŏw肵܂B
*	@param	FPM				[in]OtBbNǂݍ݂ɗp\link	nsDX9A::nsFramework::nsFilePack::DX9AFilePack	t@CpbNǗNX\endlinkw肵܂B
*	@param	FilePackName	[in]t@CpbNw肵܂B<br>
*							󕶎w肵ꍇA܂͖w̏ꍇ̓t@CpbN̓ǂݍ݂͍s܂B
*/
	IDraw2DHelper(DX9AGraphic* GM, D3DCOLOR ColorKey = 0, DX9AFilePack* FPM = NULL, const string& FilePackName = "");
														//RXgN^
/**
*	@brief	fXgN^łB
*/
	~IDraw2DHelper();									//fXgN^

/**
*	@brief	ŕێĂOtBbNǗNXi2DjSĉ܂B
*/
	void ReleaseAllDrawer();							//ێ`NXS
/**
*	@brief	w肵OtBbNǗNXi2Dj܂B
*
*			݂ȂGCAXw肵ꍇ͉s܂B
*	@param	Alias	[in]\link	CreateDrawer()	CreateDrawer\endlink\bhsɐݒ肵GCAXw肵܂B<br>
*			݂ȂGCAXw肵ꍇ͉s܂B
*/
	void ReleaseDrawer(const string& Alias);			//ێ`NX
/**
*	@brief	OtBbNǗNXi2Dj擾܂B
*	@param	Alias	[in]\link	CreateDrawer()	CreateDrawer\endlink\bhsɐݒ肵GCAXw肵܂B
*	@return	w肵OtBbNǗNXi2Djւ̃|C^Ԃ܂B݂ȂGCAXw肵ꍇNULLԂ܂B
*/
	IDraw2D* GetDrawer(const string& Alias);			//ێ`NX擾
/**
*	@brief	OtBbNǗNXi2Dj𐶐摜t@Cǂݍ݂܂B
*
*						̃GCAXw肵ꍇ͉s܂B
*	@param	FileName	[in]ǂݍމ摜t@Cw肵܂B
*	@param	Alias		[in]ǂݍ񂾉摜t@Cɑ΂GCAXw肵܂B<br>
*						󕶎w肵ꍇA܂͖w̏ꍇFileNameƓGCAXݒ肳܂B<br>
*						̃GCAXw肵ꍇ͉s܂B
*/
	void CreateDrawer(const string& FileName, const string& Alias = "");
														//ێ`NXǉ
private:
	DX9AGraphic* m_GM;									//DirectX Graphicsbp[NXւ̃|C^
	D3DCOLOR m_ColorKey;								//J[L[
	DX9AFilePack* m_FPM;								//t@CpbNǗNXւ̃|C^
	string m_FilePackName;								//t@CpbN
	map<string, IDraw2D*> m_Drawers;					//ێ`NX

	IDraw2DHelper();									//ftHgRXgN^i֎~j
	IDraw2DHelper(const IDraw2DHelper&);				//Rs[RXgN^i֎~j
	IDraw2DHelper& operator =(const IDraw2DHelper&);	//Zqi֎~j
};

}
}
}

#endif