/*************************************************
t@CFProcess.h
쐬ҁ@@Fт
@@@FvZXǗ
*************************************************/
/**
*	@file	Process.h
*	@brief	vZXǗsNX֌WłB
*/
#ifndef DX9A_FRAME_PROCESS_H
#define DX9A_FRAME_PROCESS_H

namespace nsDX9A{
namespace nsFramework{
namespace nsProcess{

//O錾
class DX9AProcess;
class CRootProcess;

//vZXNXiC^[tF[Xj
/**
*	@brief	vZXNX̃C^[tF[XłB
*
*			fXgN^protectedȂ߁AÓIȊ蓖Ă֎~Ă܂B<br>
*			KAIȊ蓖āinewjŃNX𐶐悤ɂĂB
*/
class IProcess{
protected:
/**
*	@brief	zfXgN^łB
*
*			fXgN^protectedȂ߁AÓIȊ蓖Ă֎~Ă܂B<br>
*			KAIȊ蓖āinewjŃNX𐶐悤ɂĂB
*/
	virtual ~IProcess(){}												//zfXgN^iÓIȊ蓖Ă֎~j
public:
/**
*	@brief	{NX̂܂B
*/
	virtual void Release() = 0;											//
/**
*	@brief	{NX̂ꂽ擾܂B
*	@return	{NX̂ꂽԂ܂B<br>
*			{NX̂ꂽꍇtrueÂĂȂꍇfalseԂ܂B
*/
	virtual bool IsReleased() const = 0;								//ς݂H

/**
*	@brief	{NX܂B
*
*			悤ɎĂB
*/
	virtual void Init() = 0;											//

/**
*	@brief	Os܂B
*
*			Os悤ɎĂB
*/
	virtual void OnBegin() = 0;											//vZXsiOj
/**
*	@brief	{s܂B
*
*			{s悤ɎĂB
*/
	virtual void OnMove() = 0;											//vZXsi{j
/**
*	@brief	`s܂B
*
*			`s悤ɎĂB
*/
	virtual void OnDraw() = 0;											//vZXsi`j
/**
*	@brief	㏈s܂B
*
*			㏈s悤ɎĂB
*/
	virtual void OnEnd() = 0;											//vZXsi㏈j

/**
*	@brief	|[Y܂B
*
*			|[Y悤ɎĂB
*/
	virtual void Pause() = 0;											//|[Y
/**
*	@brief	|[Y܂B
*
*			|[Y悤ɎĂB
*/
	virtual void Restart() = 0;											//|[Y
/**
*	@brief	|[YԂ擾܂B
*
*			|[YԂԂ悤ɎĂB
*	@return	|[YԂԂ܂B<br>
*			|[YԂ̏ꍇtrueA|[YԂłȂꍇfalseԂ܂B
*/
	virtual bool IsPause() const = 0;									//|[YԂH

/**
*	@brief	NXhc擾܂B
*	@return	NXhcԂ܂B<br>
*			NX̎ޖ0ȏ̈ӂȒlԂ悤ɎĂB

*/
	virtual int GetClassID() const = 0;									//NXhc擾

/**
*	@brief	vZXiɎsvZXNXj擾܂B
*	@return	vZXiɎsvZXNXjԂ܂B
*/
	virtual IProcess* GetNext() = 0;									//vZX擾
/**
*	@brief	vZXiɎsvZXNXjݒ肵܂B
*	@param	Next	[in]vZXiɎsvZXNXjw肵܂B
*	@return	vZXiɎsvZXNXjԂ܂B
*/
	virtual IProcess* SetNext(IProcess* Next) = 0;						//vZXݒ
/**
*	@brief	svZXvZXɐ؂ւ܂B
*	@param	NewTagName		[in]vZX̃^Ow肵܂B
*	@param	IsInheritParent	[in]evZXƂ̊֌Wp邩w肵܂B<br>
*							pꍇtrueAȂꍇfalsew肵ĂB
*	@param	IsInheritChild	[in]qvZXƂ̊֌Wp邩w肵܂B<br>
*							pꍇtrueAȂꍇfalsew肵ĂB
*/
	virtual void SwitchToNext(string NewTagName, bool IsInheritParent, bool IsInheritChild) = 0;
																		//vZXɐؑ

/**
*	@brief	O̎qvZX擾܂B
*	@return	O̎qvZXԂ܂BsDxɂ\[gɍsĂ܂B
*/
	virtual vector<IProcess*> GetChildrenOnBegin() = 0;					//qvZX擾iOj
/**
*	@brief	{̎qvZX擾܂B
*	@return	{̎qvZXԂ܂BsDxɂ\[gɍsĂ܂B
*/
	virtual vector<IProcess*> GetChildrenOnMove() = 0;					//qvZX擾i{j
/**
*	@brief	`掞̎qvZX擾܂B
*	@return	`掞̎qvZXԂ܂BsDxɂ\[gɍsĂ܂B
*/
	virtual vector<IProcess*> GetChildrenOnDraw() = 0;					//qvZX擾i`掞j
/**
*	@brief	㏈̎qvZX擾܂B
*	@return	㏈̎qvZXԂ܂BsDxɂ\[gɍsĂ܂B
*/
	virtual vector<IProcess*> GetChildrenOnEnd() = 0;					//qvZX擾i㏈j
/**
*	@brief	SĂ̎qvZX擾܂B
*	@return	SĂ̎qvZXԂ܂BsDxɂ\[g͍sĂ܂B
*/
	virtual multimap<string, IProcess*> GetChildren() = 0;				//qvZX擾iSāj
/**
*	@brief	qvZXo^܂B
*	@param	TagName	[in]qvZX̃^Ow肵܂B
*	@param	Child	[in]qvZXw肵܂B
*/
	virtual void RegisterChild(string TagName, IProcess* Child) = 0;	//qvZXo^
/**
*	@brief	qvZX̓o^܂B
*	@param	TagName	[in]qvZX̃^Ow肵܂B
*/
	virtual void UnregisterChild(string TagName) = 0;					//qvZXo^i^OŎwj
/**
*	@brief	qvZX̓o^܂B
*	@param	Child	[in]qvZXw肵܂B
*/
	virtual void UnregisterChild(IProcess* Child) = 0;					//qvZXo^i|C^Ŏwj

/**
*	@brief	evZX擾܂B
*	@return	evZXԂ܂B
*/
	virtual IProcess* GetParent() = 0;									//evZX擾
/**
*	@brief	evZXݒ肵܂B
*	@param	NewTagNameMine	[in]vZX̃^Ow肵܂B
*	@param	Parent			[in]evZXw肵܂B
*/
	virtual void SetParent(string NewTagNameMine, IProcess* Parent) = 0;
																		//evZXݒ

/**
*	@brief	\link	DX9AProcess	vZXǗNX\endlink擾܂B
*	@return	\link	DX9AProcess	vZXǗNX\endlinkԂ܂B
*/
	virtual DX9AProcess* GetManager() = 0;								//vZXǗNX擾
/**
*	@brief	\link	DX9AProcess	vZXǗNX\endlinkݒ肵܂B
*	@param	Manager	[in]\link	DX9AProcess	vZXǗNX\endlinkw肵܂B
*/
	virtual void SetManager(DX9AProcess* Manager) = 0;					//vZXǗNXݒ

/**
*	@brief	sDxݒ肵܂B
*
*			s͏iDx̒ႢjłB
*	@param	OnBegin	[in]O̎sDxw肵܂B
*	@param	OnMove	[in]{̎sDxw肵܂B
*	@param	OnDraw	[in]`̎sDxw肵܂B
*	@param	OnEnd	[in]㏈̎sDxw肵܂B
*/
	virtual void SetPriority(int OnBegin, int OnMove, int OnDraw, int OnEnd) = 0;
																		//sDxݒ
/**
*	@brief	sDx擾܂B
*
*			s͏iDx̒ႢjłB
*	@param	OnBegin	[out]O̎sDxi[܂B
*	@param	OnMove	[out]{̎sDxi[܂B
*	@param	OnDraw	[out]`̎sDxi[܂B
*	@param	OnEnd	[out]㏈̎sDxi[܂B
*/
	virtual void GetPriority(int& OnBegin, int& OnMove, int& OnDraw, int& OnEnd) const = 0;
																		//sDx擾
};

//vZXNXiNXj
/**
*	@brief	vZXNX̊NXłB
*
*			fXgN^protectedȂ߁AÓIȊ蓖Ă֎~Ă܂B<br>
*			KAIȊ蓖āinewjŃNX𐶐悤ɂĂB<br>
*			܂AvZXNX쐬ۂɂ͕K{NXp悤ɂĂB
*/
class CProcess : public IProcess{
/**
*	@brief	DX9AProcess	NX{NX̃vCx[goɃANZX\łB
*/
	friend class DX9AProcess;											//thNX
/**
*	@brief	CRootProcess	NX{NX̃vCx[goɃANZX\łB
*/
	friend class CRootProcess;											//thNX
public:
/**
*	@brief	RXgN^łB
*	@param	Manager	[in]\link	DX9AProcess	vZXǗNX\endlinkw肵܂B
*	@param	ClassID	[in]{NX̃NXhcw肵܂B<br>
*					NX̎ޖ0ȏ̈ӂȒlw肵ĂB
*/
	CProcess(DX9AProcess* Manager, int ClassID);						//RXgN^ivZXǗNXANXhcwj

	void Release();														//
	bool IsReleased() const;											//ς݂H

	int GetClassID() const;												//NXhc擾

	IProcess* GetNext();												//vZX擾
	IProcess* SetNext(IProcess* Next);									//vZXݒ
	void SwitchToNext(string NewTagName, bool IsInheritParent, bool IsInheritChild);
																		//vZXɐؑ

	vector<IProcess*> GetChildrenOnBegin();								//qvZX擾iOj
	vector<IProcess*> GetChildrenOnMove();								//qvZX擾i{j
	vector<IProcess*> GetChildrenOnDraw();								//qvZX擾i`掞j
	vector<IProcess*> GetChildrenOnEnd();								//qvZX擾i㏈j
	multimap<string, IProcess*> GetChildren();							//qvZX擾iSāj
	void RegisterChild(string TagName, IProcess* Child);				//qvZXo^
	void UnregisterChild(string TagName);								//qvZXo^i^OŎwj
	void UnregisterChild(IProcess* Child);								//qvZXo^i|C^Ŏwj

	IProcess* GetParent();												//evZX擾
	void SetParent(string NewTagNameMine, IProcess* Parent);			//evZXݒ

	DX9AProcess* GetManager();											//vZXǗNX擾
	void SetManager(DX9AProcess* Manager);								//vZXǗNXݒ

	void SetPriority(int OnBegin, int OnMove, int OnDraw, int OnEnd);	//sDxݒ
	void GetPriority(int& OnBegin, int& OnMove, int& OnDraw, int& OnEnd) const;
																		//sDx擾
private:
	int m_ClassID;														//NXhc
	bool m_IsReleased;													//ς݂H
	DX9AProcess* m_Manager;												//vZXǗNX

	IProcess* m_Next;													//vZX
	IProcess* m_Parent;													//evZX
	multimap<string, IProcess*> m_Children;								//qvZX
	int m_POnBegin, m_POnMove, m_POnDraw, m_POnEnd;						//sDx
	vector<IProcess*> m_TLOnBegin, m_TLOnMove, m_TLOnDraw, m_TLOnEnd;	//sDxXg

	CProcess();															//ftHgRXgN^i֎~j
	CProcess(const CProcess&);											//Rs[RXgN^i֎~j
	CProcess& operator =(const CProcess&);								//Zqi֎~j
};

//vZXNXikfoCXj
/**
*	@brief	vZXNX̃kfoCXłB
*
*			ikfoCXƂ́AuȂvNX̂Ƃłj
*/
class CNullProcess : public CProcess{
public:
/**
*	@brief	RXgN^łB
*	@param	Manager	[in]\link	DX9AProcess	vZXǗNX\endlinkw肵܂B
*	@param	ClassID	[in]{NX̃NXhcw肵܂B<br>
*					NX̎ޖ0ȏ̈ӂȒlw肵ĂB
*/
	CNullProcess(DX9AProcess* Manager, int ClassID) : CProcess(Manager, ClassID){}
																		//RXgN^ivZXǗNXANXhcwj

	void Init(){}														//

	void OnBegin(){}													//vZXsiOj
	void OnMove(){}														//vZXsi{j
	void OnDraw(){}														//vZXsi`j
	void OnEnd(){}														//vZXsi㏈j

	void Pause(){}														//|[Y
	void Restart(){}													//|[Y
	bool IsPause() const{ return(false); }								//|[YԂH
private:
	CNullProcess();														//ftHgRXgN^i֎~j
	CNullProcess(const CNullProcess&);									//Rs[RXgN^i֎~j
	CNullProcess& operator =(const CNullProcess&);						//Zqi֎~j
};

//vZXNXiŏʃvZXj
/**
*	@brief	vZXNX̍ŏʃvZXłB<br>
*			[U[`ĎgpKv͂܂B<br>
*			{NX̃NXhćuINT_MAXvłB
*/
class CRootProcess : public CProcess{
	friend class DX9AProcess;											//thNX
public:
/**
*	@brief	ftHgRXgN^łB
*/
	CRootProcess();														//ftHgRXgN^

	void Init();														//

	void OnBegin();														//vZXsiOj
	void OnMove();														//vZXsi{j
	void OnDraw();														//vZXsi`j
	void OnEnd();														//vZXsi㏈j

	void Pause();														//|[Y
	void Restart();														//|[Y
	bool IsPause() const;												//|[YԂH
private:
	bool m_IsPause;														//|[YԂH
	vector<IProcess*> m_TempList;										//vZXXgie|j
	//ȉAďo֎~\bh
	void Release(){}													//i֎~j
	bool IsReleased() const{ return(false); }							//ς݂Hi֎~j
	IProcess* GetNext(){ return(NULL); }								//vZX擾i֎~j
	IProcess* SetNext(IProcess* Next){									//vZXݒi֎~j
		UNREFERENCED_PARAMETER(Next);
		return(NULL);
	}
	void SwitchToNext(string NewTagName, bool IsInheritParent, bool IsInheritChild){
		UNREFERENCED_PARAMETER(NewTagName);
		UNREFERENCED_PARAMETER(IsInheritParent);
		UNREFERENCED_PARAMETER(IsInheritChild);
	}																	//vZXɐؑցi֎~j
	IProcess* GetParent(){ return(NULL); }								//evZX擾i֎~j
	void SetParent(string NewTagNameMine, IProcess* Parent){			//evZXݒi֎~j
		UNREFERENCED_PARAMETER(NewTagNameMine);
		UNREFERENCED_PARAMETER(Parent);
	}
	DX9AProcess* GetManager(){ return(NULL); }							//vZXǗNX擾i֎~j
	void SetManager(DX9AProcess* Manager){								//vZXǗNXݒi֎~j
		UNREFERENCED_PARAMETER(Manager);
	}
	void SetPriority(int OnBegin, int OnMove, int OnDraw, int OnEnd){	//sDxݒi֎~j
		UNREFERENCED_PARAMETER(OnBegin);
		UNREFERENCED_PARAMETER(OnMove);
		UNREFERENCED_PARAMETER(OnDraw);
		UNREFERENCED_PARAMETER(OnEnd);
	}
	void GetPriority(int& OnBegin, int& OnMove, int& OnDraw, int& OnEnd) const{
		UNREFERENCED_PARAMETER(OnBegin);
		UNREFERENCED_PARAMETER(OnMove);
		UNREFERENCED_PARAMETER(OnDraw);
		UNREFERENCED_PARAMETER(OnEnd);
	}																	//sDx擾i֎~j

	CRootProcess(const CRootProcess&);									//Rs[RXgN^i֎~j
	CRootProcess& operator =(const CRootProcess&);						//Zqi֎~j
};

//vZXǗNX
/**
*	@brief	vZXǗsNXłB
*/
class DX9AProcess{
public:
/**
*	@brief	ftHgRXgN^łB
*/
	DX9AProcess(){}														//ftHgRXgN^
/**
*	@brief	fXgN^łB
*/
	~DX9AProcess();														//fXgN^
	
/**
*	@brief	{NX܂B
*/
	void Init();														//

	//vZXs\bhFKSĂォ牺̏ŌĂяo
/**
*	@brief	Os܂B
*
*			KAOnBeginOnMoveOnDrawOnEnd̏ԂŎsĂB
*/
	void OnBegin();														//vZXsiOj
/**
*	@brief	{s܂B
*
*			KAOnBeginOnMoveOnDrawOnEnd̏ԂŎsĂB
*/
	void OnMove();														//vZXsi{j
/**
*	@brief	`s܂B
*
*			KAOnBeginOnMoveOnDrawOnEnd̏ԂŎsĂB
*/
	void OnDraw();														//vZXsi`j
/**
*	@brief	㏈s܂B
*
*			KAOnBeginOnMoveOnDrawOnEnd̏ԂŎsĂB
*/
	void OnEnd();														//vZXsi㏈j

/**
*	@brief	|[Y܂B
*/
	void Pause();														//|[Y
/**
*	@brief	|[Y܂B
*/
	void Restart();														//|[Y
/**
*	@brief	|[YԂ擾܂B
*	@return	|[YԂԂ܂B<br>
*			|[YԂ̏ꍇtrueA|[YԂłȂꍇfalseԂ܂B
*/
	bool IsPause() const;												//|[YԂH

/**
*	@brief	ŏʃvZX擾܂B
*	@return	ŏʃvZXԂ܂B
*/
	CRootProcess* GetRootProcess();										//ŏʃvZX擾
/**
*	@brief	ŏʃvZX̎qvZXo^܂B
*	@param	TagName	[in]qvZX̃^Ow肵܂B
*	@param	Process	[in]qvZXw肵܂B
*/
	void RegisterToRootProcess(string TagName, IProcess* Process);		//vZXŏʃvZXɓo^
/**
*	@brief	ŏʃvZX̎qvZX̓o^܂B
*	@param	TagName	[in]qvZX̃^Ow肵܂B
*/
	void UnregisterFromRootProcess(string TagName);						//vZXŏʃvZXo^i^OŎwj
/**
*	@brief	ŏʃvZX̎qvZX̓o^܂B
*	@param	Process	[in]qvZXw肵܂B
*/
	void UnregisterFromRootProcess(IProcess* Process);					//vZXŏʃvZXo^i|C^Ŏwj

/**
*	@brief	vZXv[ς݃vZXNXĎ擾܂B
*	@return	vZXv[ɉς݃vZXNX݂ꍇ͏vZXNXւ̃|C^A݂ȂꍇNULLԂ܂B
*/
	IProcess* GetFromProcessPool(int ProcessType);						//vZXvZXv[擾
/**
*	@brief	vZXv[ɃvZXo^܂B
*	@param	Process	[in]vZXw肵܂B
*/
	void RegisterToProcessPool(IProcess* Process);						//vZXvZXv[ɓo^
/**
*	@brief	vZXv[vZX̓o^܂B
*	@param	Process	[in]vZXw肵܂B
*/
	void UnregisterFromProcessPool(IProcess* Process);					//vZXvZXv[o^
private:
	CRootProcess m_RootProcess;											//ŏʃvZX
	multimap<int, IProcess*> m_ProcessPool;								//vZXv[

	DX9AProcess(const DX9AProcess&);									//Rs[RXgN^i֎~j
	DX9AProcess& operator =(const DX9AProcess&);						//Zqi֎~j
};

}
}
}

#endif