/*************************************************
t@CFScene.h
쐬ҁ@@Fт
@@@FV[Ǘ
*************************************************/
/**
*	@file	Scene.h
*	@brief	V[ǗsNX֌WłB
*/
#ifndef DX9A_FRAME_SCENE_H
#define DX9A_FRAME_SCENE_H

namespace nsDX9A{
namespace nsFramework{
namespace nsScene{

//V[NXiC^[tF[Xj
/**
*	@brief	V[NX̃C^[tF[XłB
*
*			fXgN^protectedȂ߁AÓIȊ蓖Ă֎~Ă܂B<br>
*			KAIȊ蓖āinewjŃNX𐶐悤ɂĂB
*/
class IScene{
protected:
/**
*	@brief	zfXgN^łB
*
*			fXgN^protectedȂ߁AÓIȊ蓖Ă֎~Ă܂B<br>
*			KAIȊ蓖āinewjŃNX𐶐悤ɂĂB
*/
	virtual ~IScene(){}												//zfXgN^iÓIȊ蓖Ă֎~j
public:
/**
*	@brief	{NX̂܂B
*
*			̂悤ɎĂB
*/
	virtual void Release() = 0;										//

/**
*	@brief	{NX܂B
*
*			悤ɎĂB
*/
	virtual void Init() = 0;										//

/**
*	@brief	Os܂B
*
*			Os悤ɎĂB
*/
	virtual void OnBegin() = 0;										//O
/**
*	@brief	{s܂B
*
*			{s悤ɎĂB
*/
	virtual void OnMove() = 0;										//{
/**
*	@brief	`s܂B
*
*			`s悤ɎĂB
*/
	virtual void OnDraw(bool IsPresent) = 0;						//`
/**
*	@brief	㏈s܂B
*
*			㏈s悤ɎĂB
*/
	virtual void OnEnd() = 0;										//㏈

/**
*	@brief	V[̎ނ擾܂B
*
*			V[̎ނ擾悤ɎĂB
*	@return	V[̎ނԂ܂B<br>
*			NX̎ޖ0ȏ̈ӂȒlԂ悤ɎĂB
*/
	virtual int GetID() const = 0;									//ނ擾
};

//V[NXikfoCXj
/**
*	@brief	V[NX̃kfoCXłB
*
*
*			ikfoCXƂ́AuȂvNX̂Ƃłj
*/
class CNullScene : public IScene{
public:
	void Release(){ delete(this); }									//

	void Init(){}													//

	void OnBegin(){}												//O
	void OnMove(){}													//{
	void OnDraw(bool IsPresent){UNREFERENCED_PARAMETER(IsPresent);}	//`
	void OnEnd(){}													//㏈

	int GetID() const{ return(-1); }								//ނ擾
};

//V[NXiC^[tF[Xj
/**
*	@brief	V[sNX̃C^[tF[XłB
*
*			fXgN^protectedȂ߁AÓIȊ蓖Ă֎~Ă܂B<br>
*			KAIȊ蓖āinewjŃNX𐶐悤ɂĂB
*/
class ISceneFactory{
protected:
/**
*	@brief	zfXgN^łB
*
*			fXgN^protectedȂ߁AÓIȊ蓖Ă֎~Ă܂B<br>
*			KAIȊ蓖āinewjŃNX𐶐悤ɂĂB
*/
	virtual ~ISceneFactory(){}										//zfXgN^iÓIȊ蓖Ă֎~j
public:
/**
*	@brief	{NX̂܂B
*
*			̂悤ɎĂB
*/
	virtual void Release() = 0;										//

/**
*	@brief	V[s܂B
*
*			s悤ɎĂB
*	@param	nScene	[in]V[̎ނw肵܂B
*	@return	V[NXԂ܂B
*/
	virtual IScene* CreateScene(int nScene) = 0;					//V[𐶐
};

//V[NXikfoCXj
/**
*	@brief	V[sNX̃kfoCXłB
*
*			ikfoCXƂ́AuȂvNX̂Ƃłj
*/
class CNullSceneFactory : public ISceneFactory{
public:
	void Release(){ delete(this); }									//

	IScene* CreateScene(int nScene){								//V[𐶐
		UNREFERENCED_PARAMETER(nScene);
		return(new CNullScene);
	}
};

//V[ǗNX
/**
*	@brief	V[ǗsNXłB
*/
class DX9AScene{
public:
/**
*	@brief	RXgN^łB
*	@param	isf		[in]gp\link	ISceneFactory	V[NX\endlinkw肵܂B
*	@param	eScene	[in]V[w肵܂B
*/
	DX9AScene(ISceneFactory* isf = NULL, int eScene = -1);			//RXgN^iV[NXAV[wj
/**
*	@brief	fXgN^łB
*/
	~DX9AScene();													//fXgN^

/**
*	@brief	V[̃vbVs܂B
*
*			V[X^bNɎw肵V[vbV܂B
*	@param	eScene	[in]vbVV[w肵܂B
*/
	void PushScene(int eScene);										//V[vbV
/**
*	@brief	V[̃Wvs܂B
*
*			gotoɑV[Jڂs܂B
*	@param	eScene	[in]WvV[w肵܂B
*/
	void JumpScene(int eScene);										//V[ړigotoj
/**
*	@brief	V[̌Ăяos܂B
*
*			gosubɑV[Jڂs܂iĂяo͏܂j
*	@param	eScene	[in]ĂяoV[w肵܂B
*/
	void CallScene(int eScene);										//V[ړigosubAĂяo͏j
/**
*	@brief	V[̌Ăяos܂B
*
*			gosubɑV[Jڂs܂iĂяo͏܂j
*	@param	eScene	[in]ĂяoV[w肵܂B
*/
	void CallSceneFast(int eScene);									//V[ړigosubAĂяo͏Ȃj
/**
*	@brief	V[̕As܂B
*
*			returnɑV[Jڂs܂B
*/
	void ReturnScene();												//V[ړireturnj

/**
*	@brief	V[s܂B<br>
*			C[vŁAKsĂB
*/
	void Run();														//V[s

/**
*	@brief	gp\link	ISceneFactory	V[NX\endlinkݒ肵܂B
*	@param	isf	[in]gp\link	ISceneFactory	V[NX\endlinkw肵܂B
*/
	void SetSceneFactory(ISceneFactory* isf);						//V[NXݒ
/**
*	@brief	gp\link	ISceneFactory	V[NX\endlink擾܂B
*	@return	gp\link	ISceneFactory	V[NX\endlinkԂ܂B
*/
	ISceneFactory* GetSceneFactory();								//V[NX擾

/**
*	@brief	V[X^bNIԂ擾܂B
*
*			V[X^bN܂͌V[kfoCX̏ꍇɁAIԂƌȂ܂B
*	@return	V[X^bNIԂ̏ꍇtrueAIԂłȂꍇfalseԂ܂B
*/
	bool IsEnd();													//IԁiV[X^bNorV[kfoCXjH

/**
*	@brief	݂\link	IScene	V[NX\endlink擾܂B
*	@return	݂\link	IScene	V[NX\endlinkԂ܂B
*/
	IScene* GetCurrentScene();										//V[̃NX擾
/**
*	@brief	O\link	IScene	V[NX\endlink擾܂B
*	@param	NumPrev	[in]ÕV[w肵܂B
*	@return	O\link	IScene	V[NX\endlinkԂ܂B
*/
	IScene* GetPreviousScene(unsigned int NumPrev = 1);				//OV[̃NX擾
private:
	void PopScene();												//V[|bv

	vector<IScene*> m_SceneStack;									//V[X^bN
	ISceneFactory* m_SceneFactory;									//V[NX
	vector<int> m_Message;											//bZ[Wi0:ȂA1:JumpA2:CallA3:CallFastA4:Returnj
	vector<int> m_NextScene;										//̃V[

	DX9AScene(const DX9AScene&);									//Rs[RXgN^i֎~j
	DX9AScene& operator =(const DX9AScene&);						//Zqi֎~j
};

}
}
}

#endif