#include "stdafx.h"
#include "../index.h"
#include "IDraw2D.h"

namespace nsDX9A{
namespace nsGraphics{
namespace nsIDraw2D{

//RXgN^iDirectX Graphicsbp[AOtBbNf[^ǂݍ݃NXi2Djwj
CDraw2D::CDraw2D(DX9AGraphic* Outer, IDraw2DReader* Reader){
	m_Reader = NULL;
	m_Outer = Outer;
	SetReader(Reader);
}
//fXgN^
CDraw2D::~CDraw2D(){
	SAFE_RELEASE(m_Reader);
}

//
void CDraw2D::Release(){
	delete(this);
}

//OtBbNf[^ǂݍ݃NXi2Dj擾(1)
IDraw2DReader* CDraw2D::GetReader(){
	return(m_Reader);
}
//OtBbNf[^ǂݍ݃NXi2Dj擾(2)
IDraw2DReader* CDraw2D::GetReader() const{
	return(m_Reader);
}
//OtBbNf[^ǂݍ݃NXi2Djݒ
bool CDraw2D::SetReader(IDraw2DReader* Reader){
	if(Reader){
		if(Reader->IsRead()){
			SAFE_RELEASE(m_Reader);
			m_Reader = Reader;
			return(true);
		}
		else{
			DX9AErrOut("Failed : CDraw2D::SetReader() Draw2DReader Not IsRead\n");
		}
	}
	else{
		SAFE_RELEASE(m_Reader);
		return(true);
	}
	return(false);
}

//ʏ]
void CDraw2D::Blt(int x, int y, BYTE a, const RECT* SrcRect, float ScalingX, float ScalingY, float Degree){
	m_Outer->GeneralBlt(m_Reader->GetTexture(), x, y, D3DCOLOR_ARGB(a, 255, 255, 255), SrcRect, D3DBLENDOP_ADD, D3DBLEND_SRCALPHA, D3DBLEND_INVSRCALPHA, ScalingX, ScalingY, Degree);
}
//F]
void CDraw2D::AddBlt(int x, int y, BYTE a, const RECT* SrcRect, float ScalingX, float ScalingY, float Degree){
	m_Outer->GeneralBlt(m_Reader->GetTexture(), x, y, D3DCOLOR_ARGB(a, 255, 255, 255), SrcRect, D3DBLENDOP_ADD, D3DBLEND_SRCALPHA, D3DBLEND_ONE, ScalingX, ScalingY, Degree);
}
//F]
void CDraw2D::SubBlt(int x, int y, BYTE a, const RECT* SrcRect, float ScalingX, float ScalingY, float Degree){
	m_Outer->GeneralBlt(m_Reader->GetTexture(), x, y, D3DCOLOR_ARGB(a, 255, 255, 255), SrcRect, D3DBLENDOP_REVSUBTRACT, D3DBLEND_SRCALPHA, D3DBLEND_ONE, ScalingX, ScalingY, Degree);
}

}
}
}