#include "stdafx.h"
#include "../index.h"
#include "FMisc.h"

namespace nsDX9A{
namespace nsMisc{
namespace nsFMisc{

//G[o
void DX9AErrOut(LPCSTR fmt, ...){
#ifdef _DEBUG
	static bool IsFirstError = true;			//Ԗڂ̃G[H
	static map<string, bool> IgnoreErrorList;	//Xg
	//Xgɓo^邩mF
	if(IgnoreErrorList.find(fmt)==IgnoreErrorList.end()){
		char buf[64 * 1024];
		const int n = wvsprintf(buf, fmt, reinterpret_cast<va_list>(&fmt+1)) - 1;
		if(buf[n]=='\n'){
			buf[n] = '\0';
		}
		char buf2[64 * 1024];
		sprintf(buf2, "L̃G[܂I\n\"%s\"\nLނ̃G[𖳎Xgɒǉ܂H", buf);
		IgnoreErrorList.insert(pair<string, bool>(fmt, MessageBox(NULL, buf2, "G[I", MB_YESNO | MB_ICONWARNING | MB_TASKMODAL)==IDYES));
	}
	if(IgnoreErrorList.find(fmt)->second){
		return;
	}
	//OL^
	char buf[64 * 1024];
	const int n = wvsprintf(buf, fmt, reinterpret_cast<va_list>(&fmt+1)) - 1;
	if(buf[n]=='\n'){
		buf[n+1] = '\0';
	}
	FILE* stream = fopen(ERRORLOG, "a");
	if(stream){
		if(IsFirstError){
			time_t Now;
			tm* TM_Now;
			Now = time(NULL);
			TM_Now = localtime(&Now);
			fprintf(stream, "ErrorLog Start -- %04d/%02d/%02d %02d:%02d:%02d\n", 
					TM_Now->tm_year+1900, TM_Now->tm_mon+1, TM_Now->tm_mday,
					TM_Now->tm_hour, TM_Now->tm_min, TM_Now->tm_sec);
			IsFirstError = false;
		}
		fprintf(stream, "%s", buf);
		fclose(stream);
	}
#endif
}

//u
void ReplaceString(string& str, const string& From, const string& To){
	string::size_type pos = 0;
	while(pos<str.size()){
		bool IsMB = ((str[pos]>=static_cast<char>(0x81) && str[pos]<=static_cast<char>(0x9F)) || 
					 (str[pos]>=static_cast<char>(0xE0) && str[pos]<=static_cast<char>(0xFF)));
		if(str.substr(pos, From.length())==From){
			str.replace(pos, From.length(), To);
			pos += To.length();
		}
		else{
			pos += IsMB ? 2 : 1;
		}
	}
}

}
}
}