#include "stdafx.h"
#include "Timer.h"

namespace nsDX9A{
namespace nsMisc{
namespace nsTimer{

//ftHgRXgN^
CTimer::CTimer(){
	timeBeginPeriod(1);
	Reset();
}
//fXgN^
CTimer::~CTimer(){
	timeEndPeriod(1);
}

//ZbgioߎԂ0ɐݒj
void CTimer::Reset(){
	m_ElapsedTime = m_PauseTime = 0;
	m_OffsetTime = timeGetTime();
	m_IsPaused = false;
}
//oߎԂ擾
DWORD CTimer::Get() const{
	return(m_IsPaused ? m_PauseTime : m_ElapsedTime);
}
//|[Y
void CTimer::Pause(){
	if(!m_IsPaused){
		m_IsPaused = true;
		m_PauseTime = m_ElapsedTime;
	}
}
//|[Y
void CTimer::Restart(){
	if(m_IsPaused){
		m_IsPaused = false;
		m_OffsetTime = timeGetTime() - m_PauseTime;
	}
}
//|[YH
bool CTimer::IsPause() const{
	return(m_IsPaused);
}

//oߎԂXV
void CTimer::Flush(){
	m_ElapsedTime = timeGetTime() - m_OffsetTime;
}

}
}
}