/*************************************************
t@CFISound.h
쐬ҁ@@Fт
@@@FTEhǗNX
*************************************************/
/**
*	@file	ISound.h
*	@brief	TEh̊ǗsNX֌WłB
*/
#ifndef DX9A_SOUND_ISOUND_H
#define DX9A_SOUND_ISOUND_H

namespace nsDX9A{
namespace nsSound{
namespace nsISound{

//TEhǗNXiC^[tF[Xj
/**
*	@brief	TEh̊ǗsNX̃C^[tF[XłB
*/
class ISound{
public:
/**
*	@brief	zfXgN^łB
*/
	virtual ~ISound(){}																		//zfXgN^

/**
*	@brief	{NX̂܂B
*/
	virtual void Release() = 0;																//

/**
*	@brief	{[擾܂B<br>
*			{[-10000`0̊ԂłB
*	@return	{[Ԃ܂B
*/
	virtual long GetVolume() const = 0;														//{[擾
/**
*	@brief	{[ݒ肵܂B<br>
*			{[-10000`0̊ԂłB
*	@param	Volume	[in]{[w肵܂B<br>
*					{[-10000`0̊ԂłB
*/
	virtual void SetVolume(long Volume) = 0;												//{[ݒ
/**
*	@brief	TEhĐ܂B
*	@param	IsRepeat	[in][vĐw肵܂B<br>
*						[vĐꍇtrueAȂꍇfalsew肵ĂB
*	@return	TEh̍ĐꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool Play(bool IsRepeat) = 0;													//Đ
/**
*	@brief	TEhĐ擾܂B
*	@return	TEhĐ̏ꍇtrueAĐłȂꍇfalseԂ܂B
*/
	virtual bool IsPlaying() const = 0;														//ĐH
/**
*	@brief	TEh~܂B
*	@return	TEh̒~ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool Stop() = 0;																//~

/**
*	@brief	\link	nsDX9A::nsSound::nsISoundReader::ISoundReader	TEhf[^ǂݍ݃NX\endlink擾܂B
*	@return	\link	nsDX9A::nsSound::nsISoundReader::ISoundReader	TEhf[^ǂݍ݃NX\endlinkԂ܂B
*/
	virtual ISoundReader* GetReader() = 0;													//TEhf[^ǂݍ݃NX擾(1)
/**
*	@brief	\link	nsDX9A::nsSound::nsISoundReader::ISoundReader	TEhf[^ǂݍ݃NX\endlink擾܂B
*	@return	\link	nsDX9A::nsSound::nsISoundReader::ISoundReader	TEhf[^ǂݍ݃NX\endlinkԂ܂B
*/
	virtual ISoundReader* GetReader() const = 0;											//TEhf[^ǂݍ݃NX擾(2)
/**
*	@brief	\link	nsDX9A::nsSound::nsISoundReader::ISoundReader	TEhf[^ǂݍ݃NX\endlinkݒ肵܂B
*	@param	Reader	[in]\link	nsDX9A::nsSound::nsISoundReader::ISoundReader	TEhf[^ǂݍ݃NX\endlinkw肵܂B<br>
*					KOpen\bhs\link	nsDX9A::nsSound::nsISoundReader::ISoundReader	TEhf[^ǂݍ݃NX\endlinkw肵ĂB
*	@return	\link	nsDX9A::nsSound::nsISoundReader::ISoundReader	TEhf[^ǂݍ݃NX\endlink̐ݒ肪ꍇtrueAsꍇfalseԂ܂B
*/
	virtual bool SetReader(ISoundReader* Reader) = 0;										//TEhf[^ǂݍ݃NXݒ
};

//TEhǗNXiSEp/dĐΉ/Xg[~OĐj
/**
*	@brief	TEh̊ǗsNXiSEpjłB
*
*			SEpł邽߁Aȉ̎dlƂȂ܂B<br>
*			EdĐɑΉĂ܂B<br>
*			EXg[~OĐ͍s܂B
*/
class CSoundSE : public ISound{
public:
/**
*	@brief	RXgN^łB
*	@param	Outer	[in]֌W\link	nsDX9A::nsSound::nsDX9ASound::DX9ASound	DirectAudiobp[NX\endlinkw肵܂B
*	@param	Reader	[in]gp\link	nsDX9A::nsSound::nsISoundReader::ISoundReader	TEhf[^ǂݍ݃NX\endlinkw肵܂B
*/
	CSoundSE(DX9ASound* Outer, ISoundReader* Reader = NULL);								//RXgN^iDirectAudiobp[ATEhf[^ǂݍ݃NXwj
/**
*	@brief	fXgN^łB
*/
	~CSoundSE();																			//fXgN^

	void Release();																			//

	long GetVolume() const;																	//{[擾
	void SetVolume(long Volume);															//{[ݒ
	bool Play(bool IsRepeat);																//Đ
	bool IsPlaying() const;																	//ĐH
	bool Stop();																			//~

	ISoundReader* GetReader();																//TEhf[^ǂݍ݃NX擾(1)
	ISoundReader* GetReader() const;														//TEhf[^ǂݍ݃NX擾(2)
	bool SetReader(ISoundReader* Reader);													//TEhf[^ǂݍ݃NXݒ
private:
	list<LPDIRECTSOUNDBUFFER> m_Buffer;														//obt@
	ISoundReader* m_Reader;																	//TEhf[^ǂݍ݃NX
	DX9ASound* m_Outer;																		//DirectAudiobp[ւ̃AhX

	CSoundSE();																				//ftHgRXgN^i֎~j
	CSoundSE(const CSoundSE&);																//Rs[RXgN^i֎~j
	CSoundSE& operator =(const CSoundSE&);													//Zqi֎~j
};

//TEhǗNXiBGMp/dĐΉ/Xg[~OĐj
/**
*	@brief	TEh̊ǗsNXiBGMpjłB
*
*			BGMpł邽߁Aȉ̎dlƂȂ܂B<br>
*			EdĐɑΉĂ܂B<br>
*			EXg[~OĐs܂B
*/
class CSoundBGM : public ISound{
public:
/**
*	@brief	RXgN^łB
*	@param	Outer	[in]֌W\link	nsDX9A::nsSound::nsDX9ASound::DX9ASound	DirectAudiobp[NX\endlinkw肵܂B
*	@param	Reader	[in]gp\link	nsDX9A::nsSound::nsISoundReader::ISoundReader	TEhf[^ǂݍ݃NX\endlinkw肵܂B
*/
	CSoundBGM(DX9ASound* Outer, ISoundReader* Reader = NULL);								//RXgN^iDirectAudiobp[ATEhf[^ǂݍ݃NXwj
/**
*	@brief	fXgN^łB
*/
	~CSoundBGM();																			//fXgN^

	void Release();																			//

	long GetVolume() const;																	//{[擾
	void SetVolume(long Volume);															//{[ݒ
	bool Play(bool IsRepeat);																//Đ
	bool IsPlaying() const;																	//ĐH
	bool Stop();																			//~

	ISoundReader* GetReader();																//TEhf[^ǂݍ݃NX擾(1)
	ISoundReader* GetReader() const;														//TEhf[^ǂݍ݃NX擾(2)
	bool SetReader(ISoundReader* Reader);													//TEhf[^ǂݍ݃NXݒ
private:
	LPDIRECTSOUNDBUFFER m_Buffer;															//obt@
	ISoundReader* m_Reader;																	//TEhf[^ǂݍ݃NX
	DX9ASound* m_Outer;																		//DirectAudiobp[ւ̃AhX

	DWORD m_BufferSize;																		//obt@̃TCY
	DWORD m_BufferNotifySize;																//obt@̃TCYiʒmԊuj
	HANDLE m_NotifyEvent[2];																//ʒmpCxgIuWFNg̃nh
	PCMWAVEFORMAT m_PCMWF;																	//ĐtH[}bg
	DWORD m_ThreadHandle;																	//ĐĎpXbh̃nh

	DWORD m_NextWrite;																		//݃ItZbg
	DWORD m_NextRead;																		//ǂݍ݃ItZbg
	DWORD m_LoopIn;																			//[vCItZbg
	DWORD m_LoopOut;																		//[vAEgItZbg
	DWORD m_Total;																			//Sf[^
	int m_Loop;																				//c胋[v
	int m_ValidBlocks;																		//LȃubŇ

	enum{ NUM_PLAY_NOTIFICATIONS = 16 };													//ubN
	enum{ BUFFER_TIME = 3 };																//Xg[obt@̕b

	static void HandleNotificationsStatic(void* pThis);										//ĐpXbh
	void HandleNotifications();																//ĐpXbhiNXj
	bool FillBlock();																		//ubNɃf[^Zbg

	CSoundBGM();																			//ftHgRXgN^i֎~j
	CSoundBGM(const CSoundBGM&);															//Rs[RXgN^i֎~j
	CSoundBGM& operator =(const CSoundBGM&);												//Zqi֎~j
};

}
}
}

#endif